//
//  coinManager.m
//  room
//
//  Created by mac on 12-6-23.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "coinManager.h"


@implementation coinManager
@synthesize roomValue           = _roomValue;
@synthesize coinValue           = _coinValue;

#pragma mark Singleton definition
GTMOBJECT_SINGLETON_BOILERPLATE(coinManager, sharedCoinManager)

#pragma mark -
#pragma mark Constructor and destructor
- (id) init
{
    self = [super init];
    if (self) {
        [self getInitHealthValueAndCoin];
        
        _roomValue         = [utils retrieveIntegerFromUserDefaultsByKey:MODEL_ROOM_VALUE];
        _coinValue         = [utils retrieveIntegerFromUserDefaultsByKey:MODEL_COIN_VALUE]; 
    }
    return self;
}

- (void) saveCoinValue{
    [utils saveIntegerToUserDefaults:_coinValue forKey:MODEL_COIN_VALUE];
}

- (void) saveRoomValue{
    [utils saveIntegerToUserDefaults:_roomValue forKey:MODEL_ROOM_VALUE];
}

- (void) getInitHealthValueAndCoin{
    float modelHealthValue = [utils retrieveIntegerFromUserDefaultsByKey:MODEL_ROOM_VALUE];
    if (modelHealthValue == 0) {
        [utils saveIntegerToUserDefaults:0 forKey:MODEL_ROOM_VALUE];
    }
    
    float modelCoinValue = [utils retrieveIntegerFromUserDefaultsByKey:MODEL_COIN_VALUE];
    if (modelCoinValue == 0) {
        [utils saveIntegerToUserDefaults:3000 forKey:MODEL_COIN_VALUE];
    }
}

- (void) plusCoinValueWithChangedValue:(int)value{
    _coinValue = _coinValue + value;
    [utils saveIntegerToUserDefaults:_coinValue forKey:MODEL_COIN_VALUE];
}

- (void) minusCoinValueWithChangedValue:(int)value{
    _coinValue = _coinValue - value;
    if (_coinValue >=  0) {
        [utils saveIntegerToUserDefaults:_coinValue forKey:MODEL_COIN_VALUE];
    }
}

- (void)plusRoomValueWithChangedValue:(int)value{
    _roomValue = _roomValue + value;
    [utils saveIntegerToUserDefaults:_roomValue forKey:MODEL_ROOM_VALUE];
}

- (void)minusRoomValueWithChangedValue:(int)value{
    _roomValue = _roomValue - value;
    if (_roomValue > 0) {
        [utils saveIntegerToUserDefaults:_roomValue forKey:MODEL_ROOM_VALUE];
    }
}
@end
