//
//  utils.h
//  room
//
//  Created by mac on 12-6-15.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.

#import <Foundation/Foundation.h>
#import "NSOperationQueue+CWSharedQueue.h"
#import "UIImageViewItemView.h"
#import "UIImageViewBKView.h"
#import <AVFoundation/AVFoundation.h>
#import <AudioToolbox/AudioToolbox.h>
#import "FXLabel.h"
#import "SHKSharer.h"
#import "Reachability.h"
#import "ASIFormDataRequest.h"
#import "ASIHTTPRequest.h"

#define MUSIC_ON        YES
#define MUSIC_OFF       NO
#define SOUND_ON        YES
#define SOUND_OFF       NO
#define APP_BACKGROUND_MUSIC_KEY @"app_config_music_status"
#define APP_SOUND_KEY            @"app_sound_key"  

#define APP_ID      @"540110132"
#define APP_NAME    @"Princess Room Designer"

typedef enum _ModelCoinViewChangeDirection{
    modelCoinPlus = 0,
    modelCoinMinus,
}ModelCoinViewChangeDirection;

@class FXLabel;
@interface utils : NSObject {
    
}
+ (UIImage *) getImageFromName:(NSString *)name;
+ (UIButton *) setButtonPropertyWithButton:(UIButton *)btn 
                                 withFrame:(CGRect)frameSize 
                                   withTag:(NSInteger)tag 
                               withUpImage:(UIImage *)upImage 
                             withDownImage:(UIImage *)downImage 
                                withTarget:(id)target 
                                withAction:(SEL)action;

+ (UIScrollView *) setScrollViewProperty:(UIScrollView *)scrollView 
                         withContentSize:(CGSize)size 
                            withDelegate:(id)delegate;

+ (FXLabel *) setLabelPropertyWithLabel:(FXLabel *)label 
                              withFrame:(CGRect)frameSize 
                            withBKColor:(UIColor *)color 
                               withFont:(UIFont *)font 
                               withText:(NSString *)text 
                        withShadowColor:(UIColor *) sColor 
                       withShadowOffSet:(CGSize)sOffset 
                         withShadowBlur:(CGFloat)shadowBlur 
                   withInnerShadowColor:(UIColor *)iColor 
                  withInnerShadowOffset:(CGSize)size 
                 withGradientStartColor:(UIColor *)gsColor 
                   withGradientEndColor:(UIColor *)geColor 
                 withGradientStartPoint:(CGPoint)gsPoint 
                   withGradientEndPoint:(CGPoint)gePoint;

+ (void) setCateButtonBkImageWithTag:(int)tag withUIView:(UIView *)view withArray:(NSArray *)array;
+ (void) addShadowColor:(UIImageViewItemView *)view;
+ (void) removeShadowColor:(UIImageViewItemView *)view;

+ (void) upDownBoardSlide:(UIView *)view withCGFloat:(CGFloat)f;
+ (void) rightLeftViewSlide:(UIView *)view withCGFloat:(CGFloat)f;

+ (void) saveIntegerToUserDefaults:(NSInteger)integerNum forKey:(NSString *)key;
+ (float) retrieveIntegerFromUserDefaultsByKey:(NSString*)key;
+ (void) setCoinChangeAnimateWithSign:(ModelCoinViewChangeDirection)direction withLable:(FXLabel *)label withChange:(int)value withImageView:(UIImageView *)imgV withDelegate:(id)delegate;

+ (void) addShadowColorForLabel:(UILabel *)label;
+ (NSString *) getCoinGiftLabelWithInt:(int)value;
+ (void) setCoinButtonShowAnimation:(UIButton *)btn;
+ (UIImage *) getCameraImageFromView:(UIImageViewBKView *)view;
+ (BOOL)saveImage:(UIImage *)image;

+ (void) coinChangeImageAnimation:(UIView *)view withDelegate:(id)delegate;
+ (void) collectCoinImageAnimation:(UIView *)view withDelegate:(id)delegate; 

+ (void)saveToUserDefaults:(NSString*)myString forKey:(NSString*)key;
+ (NSString*)retrieveFromUserDefaultsByKey:(NSString*)key;
+ (void) setBGMusicLastSaveStatus:(BOOL)status;
+ (BOOL) getbgMusicLastSave;
+ (void) setSoundLastSaveStatue:(BOOL)status;
+ (BOOL) getSoundLastSave;

+ (void) playWavSound:(CFStringRef)soundName;
+ (void) playCafSound:(CFStringRef)soundName;
+ (BOOL) isNetworkOK;

+ (UIButton *) getButtonFromSuperView:(UIView *)view withTag:(int)tag;
+ (NSString *) getGiftOpenSignFromServer:(NSString *)str;

+ (void)saveBOOLToUserDefaults:(BOOL)isTure forKey:(NSString*)key;
+ (BOOL)retrieveBOOLFromUserDefaultsByKey:(NSString*)key;

+ (BOOL) saveContextImage:(NSInteger)index withView:(UIImageViewBKView *)view;

+ (void) removeImageItemFromDocumets:(NSString *) imageName;
+ (void) setLockButtonShowAnimation:(UIButton *)btn;
@end
