//
//  utils.m
//  room
//
//  Created by mac on 12-6-15.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "utils.h"


@implementation utils

+ (UIImage *) getImageFromName:(NSString *)name{
    NSString *path = [[NSBundle mainBundle] pathForResource:name ofType:nil];
    return [UIImage imageWithContentsOfFile:path];
}

// Init Button Property
+ (UIButton *) setButtonPropertyWithButton:(UIButton *)btn 
                                 withFrame:(CGRect)frameSize 
                                   withTag:(NSInteger)tag 
                               withUpImage:(UIImage *)upImage 
                             withDownImage:(UIImage *)downImage
                                withTarget:(id)target 
                                withAction:(SEL)action
{
    btn.frame   =   frameSize;
    btn.tag     =   tag;
    [btn setBackgroundImage:upImage forState:UIControlStateNormal];
    [btn setBackgroundImage:downImage forState:UIControlEventTouchUpInside];
    [btn addTarget:target action:action forControlEvents:UIControlEventTouchUpInside];
    return btn;
}

+ (UIScrollView *) setScrollViewProperty:(UIScrollView *)scrollView 
                         withContentSize:(CGSize)size 
                            withDelegate:(id)delegate
{
    scrollView.contentSize                      = size;   
    scrollView.showsVerticalScrollIndicator     = NO;  
    scrollView.showsHorizontalScrollIndicator   = NO ;  
    scrollView.userInteractionEnabled           = YES;  
    scrollView.pagingEnabled                    = NO;
    scrollView.delegate                         = delegate;
    scrollView.scrollEnabled                    = YES;
    scrollView.alwaysBounceHorizontal           = NO;
    scrollView.alwaysBounceVertical             = NO;
    return scrollView;
}

+ (void) setCateButtonBkImageWithTag:(int)tag withUIView:(UIView *)view withArray:(NSArray *)array{
    for (UIButton * btn in [view subviews]) {
        if ([btn isKindOfClass:[UIButton class]]) {
            if((btn.tag > 9)&&(btn.tag < 18)){
                [btn setBackgroundImage:[UIImage imageNamed:[[array objectAtIndex:btn.tag-10] objectAtIndex:2]] forState:UIControlStateNormal];
            }
            
            if (btn.tag == tag) {
                [btn setBackgroundImage:[UIImage imageNamed:[[array objectAtIndex:btn.tag-10] objectAtIndex:3]] forState:UIControlStateNormal];
            }
        }
    }
}

+ (void) addShadowColor:(UIImageViewItemView *)view{
    if (view) {
        CALayer * viewLayer = [view layer];
        const CGFloat highlightColor[] = {0.90, 0.00, 0.00, 1.0};
        [viewLayer setShadowOffset:CGSizeMake(0.0, 0.0)];
        [viewLayer setShadowRadius:3.0f];
        CGColorRef shadowColor = CGColorCreate(CGColorSpaceCreateDeviceRGB(), highlightColor);
        [viewLayer setShadowColor:shadowColor];
        CGColorRelease(shadowColor);
        [viewLayer setShadowOpacity:1.0f]; 
        view.isHighLighted = YES;
    }
}
+ (void)removeShadowColor:(UIImageViewItemView *)view
{
    if (view) {
        [[view layer] setShadowOpacity:0.0f];
        view.isHighLighted = NO;
    }
}
+ (void) addShadowColorForLabel:(UILabel *)label{
    if (label) {
        CALayer * viewLayer = [label layer];
        const CGFloat highlightColor[] = {0.00, 0.90, 0.00, 1.0};
        [viewLayer setShadowOffset:CGSizeMake(0.0, 0.0)];
        [viewLayer setShadowRadius:3.0f];
        CGColorRef shadowColor = CGColorCreate(CGColorSpaceCreateDeviceRGB(), highlightColor);
        [viewLayer setShadowColor:shadowColor];
        CGColorRelease(shadowColor);
        [viewLayer setShadowOpacity:1.0f]; 
    }
}

+ (void) upDownBoardSlide:(UIView *)view withCGFloat:(CGFloat)f{
    [UIView beginAnimations:nil context:nil];
    view.frame = CGRectOffset(view.frame, 0, f);
    view.alpha = 1;
    [UIView commitAnimations];
}


+ (void) rightLeftViewSlide:(UIView *)view withCGFloat:(CGFloat)f{
    [UIView beginAnimations:nil context:nil];
    view.frame = CGRectOffset(view.frame, f, 0);
    view.alpha = 1;
    [UIView commitAnimations];
}


+ (FXLabel *) setLabelPropertyWithLabel:(FXLabel *)label 
                              withFrame:(CGRect)frameSize 
                            withBKColor:(UIColor *)color 
                               withFont:(UIFont *)font 
                               withText:(NSString *)text 
                        withShadowColor:(UIColor *) sColor 
                       withShadowOffSet:(CGSize)sOffset 
                         withShadowBlur:(CGFloat)shadowBlur 
                   withInnerShadowColor:(UIColor *)iColor 
                  withInnerShadowOffset:(CGSize)size 
                 withGradientStartColor:(UIColor *)gsColor 
                   withGradientEndColor:(UIColor *)geColor 
                 withGradientStartPoint:(CGPoint)gsPoint 
                   withGradientEndPoint:(CGPoint)gePoint{
    label.frame                = frameSize;
    label.backgroundColor      = color;
    label.font                 = font;
    label.text                 = text;
    label.textAlignment        = UITextAlignmentRight;
    label.shadowColor          = sColor;
    label.shadowOffset         = sOffset;
    label.shadowBlur           = shadowBlur;
    label.innerShadowColor     = iColor;
    label.innerShadowOffset    = size;
    label.gradientStartColor   = gsColor;
    label.gradientEndColor     = geColor;
    label.gradientStartPoint   = gsPoint;
    label.gradientEndPoint     = gePoint; 
    return label;
}

//计算时间，显示label
+ (NSString *) getCoinGiftLabelWithInt:(int)value{
    NSString * strM = [NSString stringWithFormat:@"0%d:",value/60];
    NSString * strS = nil;
    if ( value%60 > 9) {
        strS = [NSString stringWithFormat:@"%d",value%60]; 
    }else{
        strS = [NSString stringWithFormat:@"0%d",value%60]; 
    }
    return [strM stringByAppendingString:strS];
}

//设置全局int的保存
+ (void)saveIntegerToUserDefaults:(NSInteger)integerNum forKey:(NSString *)key
{
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    if (standardUserDefaults)
    { [standardUserDefaults setInteger:integerNum forKey:key];
        [standardUserDefaults synchronize];
    }
}
//读取int全局变量
+ (float)retrieveIntegerFromUserDefaultsByKey:(NSString*)key
{
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults]; 
    NSInteger val = 0;
    if (standardUserDefaults)
        val = [standardUserDefaults integerForKey:key];
    return val;
}

+ (void) setCoinChangeAnimateWithSign:(ModelCoinViewChangeDirection)direction withLable:(FXLabel *)label withChange:(int)value withImageView:(UIImageView *)imgV withDelegate:(id)delegate{
    [label setHidden:NO];
    [imgV setHidden:NO];
    switch (direction) {
        case modelCoinPlus: 
            label.innerShadowColor     = [UIColor colorWithRed:0.46 green:0.88 blue:0.4 alpha:1.0];
            label.gradientStartColor   = [UIColor colorWithRed:0.46 green:0.88 blue:0.4 alpha:1.0];
            label.gradientEndColor     = [UIColor colorWithRed:0.46 green:0.88 blue:0.4 alpha:1.0];
            label.text = [NSString stringWithFormat:@"+%d",value];
            break;
        case modelCoinMinus:
            label.innerShadowColor     = [UIColor yellowColor];
            label.gradientStartColor   = [UIColor yellowColor];
            label.gradientEndColor     = [UIColor yellowColor];
            label.text = [NSString stringWithFormat:@"-%d",value];
            break;
        default:
            break;
    }
    [self coinChangeImageAnimation:imgV withDelegate:delegate];
    [self coinChangeImageAnimation:label withDelegate:delegate];
}

+ (void) coinChangeImageAnimation:(UIView *)view withDelegate:(id)delegate{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
    [UIView setAnimationDuration:1.5];
    [UIView setAnimationDelegate:delegate];
    [UIView setAnimationDidStopSelector:@selector(coinAnimationStop:finish:context:)];
    view.frame = CGRectOffset(view.frame, 0, -80);
    view.alpha = 1;
    [UIView commitAnimations];
}

+ (void) collectCoinImageAnimation:(UIView *)view withDelegate:(id)delegate{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationDuration:2.0];
    [UIView setAnimationDelegate:delegate];
    [UIView setAnimationDidStopSelector:@selector(collectAnimationStop:finish:context:)];
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        view.frame = CGRectOffset(view.frame, -385, -80);
    }else{
        view.frame = CGRectOffset(view.frame, -945, -155);
    }
    
    view.alpha = 1;
    [UIView commitAnimations];
}

+ (void) setCoinButtonShowAnimation:(UIButton *)btn{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    [UIView setAnimationDuration:1];
    [UIView setAnimationRepeatAutoreverses:YES];
    [UIView setAnimationRepeatCount:999999];
    //[UIView setAnimationDelegate:self];
    btn.transform = CGAffineTransformMakeScale(1.25, 1.25);
    [UIView commitAnimations];
}

+ (void) setLockButtonShowAnimation:(UIButton *)btn{
    [UIView beginAnimations:nil context:nil];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    [UIView setAnimationDuration:1];
    [UIView setAnimationRepeatAutoreverses:YES];
    [UIView setAnimationRepeatCount:3];
    //[UIView setAnimationDelegate:self];
    btn.transform = CGAffineTransformMakeScale(1.15, 1.15);
    [UIView commitAnimations];
}

+ (UIImage *) getCameraImageFromView:(UIImageViewBKView *)view{
    UIGraphicsBeginImageContextWithOptions(view.bounds.size, view.opaque, 0);
    [view.layer renderInContext:UIGraphicsGetCurrentContext()];
    UIImage *result = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return result;
}

+ (BOOL)saveImage:(UIImage *)image
{
    UIImageWriteToSavedPhotosAlbum(image, nil, nil, nil);
	[[SHKActivityIndicator currentIndicator] displayCompleted:@"Saved!"];
	
	return YES;
}

+ (BOOL)getSoundLastSave{
    NSString *soundStatus = [self retrieveFromUserDefaultsByKey:APP_SOUND_KEY];
    if (soundStatus) {
        if ([soundStatus intValue]==0) {
            return NO;
        }else{
            return YES;
        }
    }else
    {
        [self setSoundLastSaveStatue:SOUND_ON];
        return YES;
    }
}

+ (void) setSoundLastSaveStatue:(BOOL)status{
    if (status) {
        [self saveToUserDefaults:@"1" forKey:APP_SOUND_KEY];
    }else{
        [self saveToUserDefaults:@"0" forKey:APP_SOUND_KEY];        
    }
}

+ (BOOL) getbgMusicLastSave
{
    NSString *musicStatus = [self retrieveFromUserDefaultsByKey:APP_BACKGROUND_MUSIC_KEY];
    if (musicStatus) {
        if ([musicStatus intValue]==0) {
            return NO;
        }else{
            return YES;
        }
    }else
    {
        [self setBGMusicLastSaveStatus:MUSIC_ON];
        return YES;
    }
}

+ (void) setBGMusicLastSaveStatus:(BOOL)status
{
    if (status) {
        [self saveToUserDefaults:@"1" forKey:APP_BACKGROUND_MUSIC_KEY];
    }else{
        [self saveToUserDefaults:@"0" forKey:APP_BACKGROUND_MUSIC_KEY];        
    }
}

+ (void)saveToUserDefaults:(NSString*)myString forKey:(NSString*)key
{
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    if (standardUserDefaults)
    { [standardUserDefaults setObject:myString forKey:key];
        [standardUserDefaults synchronize];
    }
}


+ (NSString*)retrieveFromUserDefaultsByKey:(NSString*)key
{
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults]; 
    NSString *val = nil;
    if (standardUserDefaults)
        val = [standardUserDefaults objectForKey:key];
    return val;
}

+ (void) playWavSound:(CFStringRef)soundName
{
    
    CFBundleRef mainBundle;
    SystemSoundID soundFileObject;
    mainBundle = CFBundleGetMainBundle ();
    CFURLRef soundFileURLRef = CFBundleCopyResourceURL ( mainBundle, soundName, CFSTR ("wav"),NULL);
    AudioServicesCreateSystemSoundID (soundFileURLRef,&soundFileObject );
    AudioServicesPlaySystemSound(soundFileObject);
    
}

+ (void) playCafSound:(CFStringRef)soundName
{
    CFBundleRef mainBundle;
    SystemSoundID soundFileObject;
    mainBundle = CFBundleGetMainBundle ();
    CFURLRef soundFileURLRef = CFBundleCopyResourceURL ( mainBundle, soundName, CFSTR ("caf"),NULL);
    AudioServicesCreateSystemSoundID (soundFileURLRef,&soundFileObject );
    AudioServicesPlaySystemSound(soundFileObject);
}

+ (BOOL) isNetworkOK
{
    BOOL Reachable = NO;
    Reachability *reach = [Reachability reachabilityWithHostName:@"www.apple.com"];
    NetworkStatus status = [reach currentReachabilityStatus];            
    switch (status) {
        case NotReachable:{
            Reachable = NO;
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"Network not available. Please check your settings or verify data service with your provider."  delegate:self  cancelButtonTitle:@"OK" otherButtonTitles:nil];
            [alert show];
            [alert release];
        }
            break;
        default:
            Reachable = YES;
            break;
    }
    return Reachable;
}

+ (UIButton *) getButtonFromSuperView:(UIView *)view withTag:(int)tag{
    for (UIButton * btn in [view subviews]) {
        if ([btn isKindOfClass:[UIButton class]]) {
            if (btn.tag == tag) {
                return btn;
            }
        }
    }
    UIButton * oriBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    return oriBtn;
}

+ (void)saveBOOLToUserDefaults:(BOOL)isTure forKey:(NSString*)key
{
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    if (standardUserDefaults)
    { [standardUserDefaults setBool:isTure forKey:key];
        [standardUserDefaults synchronize];
    }
}


+ (BOOL)retrieveBOOLFromUserDefaultsByKey:(NSString*)key
{
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults]; 
    BOOL val = NO;
    if (standardUserDefaults)
        val = [standardUserDefaults boolForKey:key];
    return val;
}

+ (NSString *) getGiftOpenSignFromServer:(NSString *)str{
    NSURL *url = [NSURL URLWithString:str];
    ASIHTTPRequest *request = [ASIHTTPRequest requestWithURL:url];
    [ASIHTTPRequest setDefaultTimeOutSeconds:3];
    [request startSynchronous];
    NSError *error = [request error];
    if (!error) {
        NSString * response = [request responseString];
        return response;
    }else{
        NSString * response = @"001";
        return response;
    }    
}
//图片保存到本程序下
+ (BOOL) saveContextImage:(NSInteger)index withView:(UIImageViewBKView *)view{
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask,YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    NSString *savedImagePath = [documentsDirectory stringByAppendingPathComponent:[NSString stringWithFormat:@"%d.png",index]];
    NSData *imageData = UIImagePNGRepresentation([utils getCameraImageFromView:view]);
    [imageData writeToFile:savedImagePath atomically:NO];  
    return YES;
}

+ (void) removeImageItemFromDocumets:(NSString *) imageName{
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES); 
    NSString *documentsDirectoryPath = [paths objectAtIndex:0];
    
    NSString *databaseFile = [documentsDirectoryPath stringByAppendingPathComponent:imageName];
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    [fileManager removeItemAtPath:databaseFile error:NULL];
}
@end
