//
//  giftBoardView_iPhone.m
//  room
//
//  Created by mac on 12-6-30.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "giftBoardView_iPhone.h"


@implementation giftBoardView_iPhone
@synthesize target = target;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        
        self.image = [utils getImageFromName:@"rateboard_iphone.png"];
        self.userInteractionEnabled  = YES;
        
        UIButton * rateBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        rateBtn = [utils setButtonPropertyWithButton:rateBtn
                                           withFrame:CGRectMake(90.0, 150.0, 70.0, 30.0)
                                             withTag:0 
                                         withUpImage:nil
                                       withDownImage:nil
                                          withTarget:self 
                                          withAction:@selector(rateBtnPressed)];
        [self addSubview:rateBtn];
        
        UIButton * mailBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        mailBtn = [utils setButtonPropertyWithButton:mailBtn
                                           withFrame:CGRectMake(205.0, 150.0, 70.0, 30.0) 
                                             withTag:0 
                                         withUpImage:nil 
                                       withDownImage:nil 
                                          withTarget:self 
                                          withAction:@selector(mailBtnPressed)];
        [self addSubview:mailBtn];
        
        _textViewBK = [[UIImageView alloc] initWithFrame:CGRectMake(110.0, 215, 160.0, 35)];
        _textViewBK.image = [utils getImageFromName:@"rate_textView_iphone.png"];
        _textViewBK.userInteractionEnabled = YES;
        [self addSubview:_textViewBK];
        [_textViewBK release];
        
        _textField = [[UITextField alloc] initWithFrame:CGRectMake(8.0, 5.0, 120, 26)];
        [_textField setBorderStyle:UITextBorderStyleNone]; 
        _textField.placeholder               = @"gift code"; 
        _textField.autocorrectionType        = UITextAutocorrectionTypeNo;
        _textField.autocapitalizationType    = UITextAutocapitalizationTypeNone;
        _textField.returnKeyType             = UIReturnKeyDone;
        _textField.clearButtonMode           = UITextFieldViewModeWhileEditing;
        _textField.delegate                  = self;
        _textField.backgroundColor           = [UIColor clearColor];
        _textField.alpha = 0.7;
        _textField.font                      = [UIFont fontWithName:@"Times New Roman" size:18];
        [_textViewBK addSubview:_textField];
        [_textField release];
       
        UIButton * unlockCodeBtn=[UIButton buttonWithType:UIButtonTypeCustom];
        unlockCodeBtn = [utils setButtonPropertyWithButton:unlockCodeBtn 
                                                 withFrame:CGRectMake(120, 0, 40, 35) 
                                                   withTag:1 
                                               withUpImage:nil 
                                             withDownImage:nil 
                                                withTarget:self 
                                                withAction:@selector(unlockCodeBtnPressed:)];
        unlockCodeBtn.alpha = 0.7;
        [unlockCodeBtn setBackgroundColor:[UIColor clearColor]];
        [_textViewBK addSubview:unlockCodeBtn];
        
        UIButton * closeButton = [UIButton buttonWithType:UIButtonTypeCustom];
        closeButton = [utils setButtonPropertyWithButton:closeButton 
                                               withFrame:CGRectMake(325, 0, 50, 50)
                                                 withTag:0 
                                             withUpImage:[utils getImageFromName:@"backButton.png"] 
                                           withDownImage:[utils getImageFromName:@"backButton.png"] 
                                              withTarget:self 
                                              withAction:@selector(removeFromSuperview)];
        [self addSubview:closeButton];
    }
    return self;
}

- (void) rateBtnPressed{
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"itms-apps://ax.itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?type=Purple+Software&id=%@", APP_ID]]];
}

- (void) mailBtnPressed{
    NSString *body=[NSString  stringWithFormat:@"I have rated %@, please send me a gift code for free cash.\n Nickname is ____ that was created for your review.",APP_NAME];
    [self mailToGetUnlockCode:@"gift code" Body:body];
}


-(void)textFieldDidBeginEditing:(UITextField *)textField{
    [utils upDownBoardSlide:_textViewBK withCGFloat:-150.0];
}

-(void)textFieldDidEndEditing:(UITextField *)textField{
    [utils upDownBoardSlide:_textViewBK withCGFloat:150.0];
}

-(BOOL) textFieldShouldReturn:(UITextField *)textField
{
    [self unlockCodeBtnPressed:nil];
    [textField resignFirstResponder];
    return YES;
}

-(void)unlockCodeBtnPressed:(id)btn{
    //验证码
    NSDate *now = [NSDate date];
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    dateFormatter.dateFormat = @"yyyy:MM:dd";
    [dateFormatter setTimeZone:[NSTimeZone systemTimeZone]];
    NSLog(@"The Current Time is %@",[dateFormatter stringFromDate:now]);
    NSString *dateString=[dateFormatter stringFromDate:now];
    NSInteger month=[[[dateString componentsSeparatedByString:@":"] objectAtIndex:1] intValue];
    [dateFormatter release];
 
    if([self checkUnlockCodeIsValid:month userInputUnlockCode:_textField.text]){
        [utils saveBOOLToUserDefaults:YES forKey:GIFT_HAVE_USED];
        [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:1000];
        
        [[NSNotificationCenter defaultCenter] postNotificationName:@"Rate_Us_Complete" object:nil userInfo:nil];
        //发一条notification表示已经购买成功了
        
        
        
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Congratulations!" 
                                                        message:@"Earn 1000 Cash !" 
                                                       delegate:nil 
                                              cancelButtonTitle:@"OK" 
                                              otherButtonTitles:nil, nil];
        [alert show];
        [alert release];
        [self removeFromSuperview];
    }else{
        _textField.textColor=[UIColor redColor];

        CABasicAnimation *animation = 
        [CABasicAnimation animationWithKeyPath:@"position"];
        [animation setDuration:0.05];
        [animation setRepeatCount:4];
        [animation setAutoreverses:YES];
        [animation setFromValue:[NSValue valueWithCGPoint:
                                 CGPointMake([_textViewBK center].x - 15, [_textViewBK center].y)]];
        [animation setToValue:[NSValue valueWithCGPoint:
                               CGPointMake([_textViewBK center].x + 15, [_textViewBK center].y)]];
        [[_textViewBK layer] addAnimation:animation forKey:@"position"];
    }
    
    
    
    
}

-(BOOL)checkUnlockCodeIsValid:(NSInteger)month userInputUnlockCode:(NSString*)unlockCode{
    NSString *lowerCaseUnlockCode=[unlockCode uppercaseString];
    
    switch (month) {
        case 1:
            if([lowerCaseUnlockCode isEqualToString:@"NT6Y7ARM4LEM"])
                return YES;
            break;
        case 2:
            if([lowerCaseUnlockCode isEqualToString:@"JRYJTM43EXKR"])
                return YES;
            break;
        case 3:
            if([lowerCaseUnlockCode isEqualToString:@"LLR6MM74MJNR"])
                return YES;
            break;
        case 4:
            if([lowerCaseUnlockCode isEqualToString:@"YXKX96NHRXJR"])
                return YES;
            break;
        case 5:
            if([lowerCaseUnlockCode isEqualToString:@"JX4X3WFT9KTJ"])
                return YES;
            break;
        case 6:
            if([lowerCaseUnlockCode isEqualToString:@"T9NR7PE7R9RE"])
                return YES;
            break;
        case 7:
            if([lowerCaseUnlockCode isEqualToString:@"R6HTJYF9RYPN"])
                return YES;
            break;
        case 8:
            if([lowerCaseUnlockCode isEqualToString:@"FNKHFNKXLK47"])
                return YES;
            break;
        case 9:
            if([lowerCaseUnlockCode isEqualToString:@"PM7F7TT9YJFH"])
                return YES;
            break;
        case 10:
            if([lowerCaseUnlockCode isEqualToString:@"49PP3K779LEN"])
                return YES;
            break;
        case 11:
            if([lowerCaseUnlockCode isEqualToString:@"LHAYM44H4M9A"])
                return YES;
            break;
        case 12:
            if([lowerCaseUnlockCode isEqualToString:@"9PAF3E3MJF9H"])
                return YES;
            break;
        default:
            return  NO;
            break;
    }
    return  NO;
    
}


- (void)mailToGetUnlockCode:(NSString *)sub Body:(NSString *)body 
{
    if (![MFMailComposeViewController canSendMail]) {
        NSLog(@"Your device is not configured for sending email");
        return;
    }
    
    MFMailComposeViewController *mc = [[MFMailComposeViewController alloc] init];
    mc.mailComposeDelegate = target;
    NSArray *recipients = [NSArray arrayWithObjects:@"design@sharkmobi.com", nil];
    
    [mc setToRecipients:recipients];
    
    [mc setSubject:sub];
    [mc setMessageBody:body isHTML:NO];
    
    [target presentModalViewController:mc animated:YES]; 
    [mc release];
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

- (void)dealloc
{
    [super dealloc];
}

@end
