//
//  roomDesignController_iPhone.h
//  room
//
//  Created by mac on 12-6-15.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SQLiteOperation.h"
#import "scrollItemView_iPhone.h"
#import "UIImageViewItemView.h"
#import "UIImageViewBKView.h"
#import "UIImageViewExpandDelegate.h"
#import "utils.h"
#import "FXLabel.h"
#import "coinManager.h"
#import "SHKFacebook.h"
#import "iToast.h"
#import "MKStoreManager.h"
#import "buttonControllerDefine.h"
#import "giftBoardView_iPhone.h"
#import "AdWhirlView.h"
#import "roomAppDelegate.h"

@interface roomDesignController_iPhone : UIViewController <UIScrollViewDelegate,UIImageViewExpandDelegate,UIImageViewExpandBKDelegate,UIAlertViewDelegate,AdWhirlDelegate>{
    UIImageViewBKView              *   _containerView;
    UIView                         *   _itemPickOpearteView;
    UIScrollView                   *   _itemScrollView;
    
    //6个控制按钮的View
    UIView                         *   _controlButtonSuperView; 
    
    NSArray                        *   _currentGroupItems;
    NSArray                        *   _cateButtonArray; 
    NSArray                        *   _purchaseIdArray;
    
    UIImageViewItemView            *   _currentItemView;
    NSMutableDictionary            *   _pickedItemsDict;

    
    NSInteger _pickUniqueIndex;
 
    UIButton                        *  _designButton; 
    UIButton                        *  _lockBKButton;     
    FXLabel                         *  _coinShowLabel;//左上角的金币显示    
    FXLabel                         *  _roomValueLabel; //右上角的Value显示     
    FXLabel                         *  _coinAnimationLabel; //用于显示金币变动的动画
    UIImageView                     *  _coinAnimationView;
    UIImageView                     *  _collectAnimationView;
    
    UILabel                         *  _collectCoinTip; 
    UILabel                         *  _collectCoinLabel; 
    UIButton                        *  _collectCoinButton; 
    NSInteger   _timeCountNum;//用于倒计时
    UIButton                        *  _showButton;
    UIButton                        *  _giftButton;
    giftBoardView_iPhone            *  _giftBoardView; 
    AdWhirlView                     *  _adWhirlView;
    
    UIButton                        *  _saveContextButton; 
    
    NSInteger       pointBKImage;    
    NSTimer     *   timeToStart;
    
    //从编辑相册进来的时候应该有一个
    NSInteger   _bKId;
    NSInteger   _bKHomeValue;
    
    //用于标识购买，取消等动作
    int  itemPickTag;
    UIButton    *   _buyItemButton;
    UIButton    *   _cancelItemButton;
    
    //上一次试用item的情况
    int  _lastPickItemViewIndex;
    
}
@property (nonatomic, retain) UIImageViewBKView            *   containerView;
@property (nonatomic, retain) UIView                       *   itemPickOpearteView;
@property (nonatomic, retain) UIScrollView                 *   itemScrollView;
@property (nonatomic, retain) NSArray                      *   currentGroupItems;
@property (nonatomic, retain) NSArray                      *   cateButtonArray;
@property (nonatomic, retain) UIImageViewItemView          *   currentItemView;
@property (nonatomic, retain) NSMutableDictionary          *   pickedItemsDict;  
@property (nonatomic) NSInteger pickUniqueIndex;

@property (nonatomic, retain) UIButton * designButton;
@property (nonatomic, retain) UIButton * lockBKButton;

@property (nonatomic, retain) FXLabel               * coinShowLabel;
@property (nonatomic, retain) FXLabel               * roomValueLabel;
@property (nonatomic, retain) FXLabel               * coinAnimationLabel;
@property (nonatomic, retain) UIImageView           * coinAnimationView;  
@property (nonatomic, retain) UILabel               * collectCoinLabel;
@property (nonatomic, retain) UIButton              * showButton;
@property (nonatomic, retain) giftBoardView_iPhone  * giftBoardView;
@property (nonatomic, assign) NSInteger bKId;
@property (nonatomic, assign) NSInteger bKHomeValue;

- (id) initWithIndex:(int) index;
- (void) initContainerViewWithIndex:(int)index;
- (void) initItemPickOperateView;
- (void) initItemDataWithCateIndex:(int)index;
- (void) initOperationButtons;
- (void) cleanAllShadowOfItems;
- (void) isPickViewHalfHide;

- (void) initMainButtons;
- (void) setControllPoint:(UIImageViewItemView *)point;
- (void) roomValueCalculateWithSign:(ModelCoinViewChangeDirection)direction withChange:(int)value;

- (void) leftArrowButtonPress;
- (void) rightArrowButtonPress;
- (void) cameraButtonPressed;
- (void) coinShowButtonPressed;

- (void) cancelItemButtonPressed;
@end
