//
//  roomDesignController_iPhone.m
//  room
//
//  Created by mac on 12-6-15.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "roomDesignController_iPhone.h"


@implementation roomDesignController_iPhone
@synthesize containerView       = _containerView;
@synthesize itemPickOpearteView = _itemPickOpearteView;
@synthesize itemScrollView      = _itemScrollView;
@synthesize currentGroupItems   = _currentGroupItems;
@synthesize cateButtonArray     = _cateButtonArray;
@synthesize currentItemView     = _currentItemView;  
@synthesize pickedItemsDict     = _pickedItemsDict;
@synthesize pickUniqueIndex     = _pickUniqueIndex;
@synthesize designButton        = _designButton;
@synthesize lockBKButton        = _lockBKButton;
@synthesize coinShowLabel       = _coinShowLabel; 

@synthesize roomValueLabel      = _roomValueLabel;  
@synthesize coinAnimationLabel  = _coinAnimationLabel;
@synthesize coinAnimationView   = _coinAnimationView;
@synthesize collectCoinLabel    = _collectCoinLabel; 
@synthesize showButton          = _showButton;  
@synthesize giftBoardView       = _giftBoardView;
@synthesize bKId                = _bKId;
@synthesize bKHomeValue         = _bKHomeValue;
   

- (id) initWithIndex:(int) index{
    self = [super init];
    if (self) {
        self.view.backgroundColor = [UIColor colorWithRed:1.0 green:0.90 blue:0.90 alpha:1.0];
        pointBKImage = index;
        
        _purchaseIdArray = [[[SQLiteOperation sharedSQLOpt] selectData:@"select id, inappkey from tb_inapp order by id asc" resultColumns:2] retain];
        _cateButtonArray = [[[SQLiteOperation sharedSQLOpt] selectData:@"select cateId,cateName,catePic,cateOther from tb_cate" resultColumns:4] retain];
        
        [self initItemDataWithCateIndex:1];
        [self initContainerViewWithIndex:index];
        //[self initModelShowView];
    }
    return self;
}

- (void)viewWillAppear:(BOOL)animated{
    _pickUniqueIndex = 1;
    _lastPickItemViewIndex = 0;
    if (_bKId != 0) {        
        NSString * sqlStr = [NSString stringWithFormat:@"select itemId,itemBk,itemName,itemCenter_x,itemCenter_y,itemTrans_a,itemTrans_b,itemTrans_c,itemTrans_d,itemTrans_tx,itemTrans_ty,itemOther,itemValue from tb_saveItem where itemBk = '%d' order by itemId asc",_bKId];
        
        NSArray * oldItemArray = [[[SQLiteOperation sharedSQLOpt] selectData:sqlStr resultColumns:13] retain];
       
        //项目加载在房间界面上
        for (int i = 0; i < [oldItemArray count]; i++) {
            UIImage * img = [utils getImageFromName:[[oldItemArray objectAtIndex:i] objectAtIndex:2]];
            _currentItemView = [[UIImageViewItemView alloc] initWithFrame:CGRectMake(self.view.frame.size.width*0.5, self.view.frame.size.height*0.3, img.size.width*0.3, img.size.height*0.3)];
            _currentItemView.center = CGPointMake([[[oldItemArray objectAtIndex:i] objectAtIndex:3] floatValue], [[[oldItemArray objectAtIndex:i] objectAtIndex:4] floatValue]);
            _currentItemView.userInteractionEnabled = YES;
            _currentItemView.image = img;
            _currentItemView.transform = CGAffineTransformMake([[[oldItemArray objectAtIndex:i] objectAtIndex:5] floatValue], [[[oldItemArray objectAtIndex:i] objectAtIndex:6] floatValue], [[[oldItemArray objectAtIndex:i] objectAtIndex:7] floatValue], [[[oldItemArray objectAtIndex:i] objectAtIndex:8] floatValue], [[[oldItemArray objectAtIndex:i] objectAtIndex:9] floatValue], [[[oldItemArray objectAtIndex:i] objectAtIndex:10] floatValue]);
            
            //记录对应图片的名字
            _currentItemView.imageName = [[oldItemArray objectAtIndex:i] objectAtIndex:2];
            [_currentItemView setupHandGestureRecognizerWithDraggable:YES
                                                        withPinchable:YES
                                                       withRotateable:NO 
                                                          withTapable:YES
                                                    withMinPinchScale:0.5
                                                    withMaxPinchScale:1.5];
            [_currentItemView setDelegate:self];
            [_currentItemView setPickUniqueNumber:_pickUniqueIndex];
            [_currentItemView setPickViewCoin:[[[oldItemArray objectAtIndex:i] objectAtIndex:12] intValue]];
            [_containerView addSubview:_currentItemView];
            [_pickedItemsDict setObject:_currentItemView forKey:[NSString stringWithFormat:@"%d",_pickUniqueIndex]];
            [_currentItemView release];
            _pickUniqueIndex = _pickUniqueIndex + 1;
        }
        [[coinManager sharedCoinManager] setRoomValue:_bKHomeValue];
        [[coinManager sharedCoinManager] saveRoomValue];
    }else{
        //是不是需要初始化homeValue为0
    }
    [self initMainButtons];
    [self initItemPickOperateView];
}

//初始化所有的按钮和标签，包括设计、锁屏、模型、金币、房间价值等按钮标签
- (void) initMainButtons{
    _designButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _designButton = [utils setButtonPropertyWithButton:_designButton 
                                             withFrame:CGRectMake(420.0, 255.0, 50.0, 60.0) 
                                               withTag:0 
                                           withUpImage:[utils getImageFromName:@"designButton.png"] 
                                         withDownImage:[utils getImageFromName:@"designButton.png"] 
                                            withTarget:self 
                                            withAction:@selector(designButtonPressed:)];
    [self.view addSubview:_designButton];
    
    _lockBKButton = [UIButton buttonWithType:UIButtonTypeCustom];
    //lockbutton状态切换，当tag为1时，背景可以任意拖动，当tag为2时，锁住背景
    _lockBKButton = [utils setButtonPropertyWithButton:_lockBKButton 
                                             withFrame:CGRectMake(5.0, 75.0, 45.0, 40.0)
                                               withTag:LOCK_BK_BUTTON_STATE_UNLOCKED 
                                           withUpImage:[utils getImageFromName:@"unlockButton.png"]
                                         withDownImage:[utils getImageFromName:@"unlockButton.png"]
                                            withTarget:self
                                            withAction:@selector(lockBKButtonPressed:)];
    [self.view addSubview:_lockBKButton];
    
    UIButton * coinShowButton = [UIButton buttonWithType:UIButtonTypeCustom];
    coinShowButton = [utils setButtonPropertyWithButton:coinShowButton 
                                               withFrame:CGRectMake(5.0, 5.0, 120.0, 45.0)
                                                 withTag:COIN_SHOW_BUTTON_TAG
                                             withUpImage:[utils getImageFromName:@"coinShowButton.png"]
                                           withDownImage:[utils getImageFromName:@"coinShowButton.png"]
                                              withTarget:self
                                              withAction:@selector(coinShowButtonPressed)];
    [self.view addSubview:coinShowButton];
    
    UIButton * roomValueButton = [UIButton buttonWithType:UIButtonTypeCustom];
    roomValueButton = [utils setButtonPropertyWithButton:roomValueButton
                                                withFrame:CGRectMake(380.0, 10.0, 90.0, 35.0) 
                                                  withTag:ROOM_VALUE_BUTTON_TAG 
                                              withUpImage:[utils getImageFromName:@"homeValueButton.png"] 
                                            withDownImage:[utils getImageFromName:@"homeValueButton.png"]
                                               withTarget:self 
                                               withAction:@selector(roomValueButtonPressed:)];
    [self.view addSubview:roomValueButton];
    
    _coinShowLabel = [[FXLabel alloc] init];
    _coinShowLabel = [utils setLabelPropertyWithLabel:_coinShowLabel 
                                            withFrame:CGRectMake(5.0, 15.0, 105.0, 30.0) 
                                          withBKColor:[UIColor clearColor] 
                                             withFont:[UIFont fontWithName:@"Helvetica-Bold" size:14.0] 
                                             withText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]
                                      withShadowColor:[UIColor blackColor] 
                                     withShadowOffSet:CGSizeZero 
                                       withShadowBlur:18.0f 
                                 withInnerShadowColor:[UIColor yellowColor] 
                                withInnerShadowOffset:CGSizeMake(1.0f, 2.0f) 
                               withGradientStartColor:[UIColor yellowColor]
                                 withGradientEndColor:[UIColor yellowColor]
                               withGradientStartPoint:CGPointMake(0.0f, 0.5f) 
                                 withGradientEndPoint:CGPointMake(0.0f, 0.5f)];
    [self.view addSubview:_coinShowLabel];
    
    _roomValueLabel = [[FXLabel alloc] init];
    _roomValueLabel = [utils setLabelPropertyWithLabel:_roomValueLabel
                                             withFrame:CGRectMake(360.0, 15.0, 105.0, 30.0)
                                           withBKColor:[UIColor clearColor] 
                                              withFont:[UIFont fontWithName:@"Helvetica-Bold" size:14.0]
                                              withText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] roomValue]]
                                       withShadowColor:[UIColor blackColor]
                                      withShadowOffSet:CGSizeZero
                                        withShadowBlur:18.0f
                                  withInnerShadowColor:[UIColor yellowColor] 
                                 withInnerShadowOffset:CGSizeMake(1.0f, 2.0f) 
                                withGradientStartColor:[UIColor yellowColor]
                                  withGradientEndColor:[UIColor yellowColor]
                                withGradientStartPoint:CGPointMake(0.0f, 0.5f) 
                                  withGradientEndPoint:CGPointMake(0.0f, 0.5f)];
    [self.view addSubview:_roomValueLabel];
    
    _coinAnimationLabel = [[FXLabel alloc] init];
    _coinAnimationLabel = [utils setLabelPropertyWithLabel:_coinAnimationLabel 
                                                 withFrame:CGRectMake(160.0, 140.0, 105.0, 30.0) 
                                               withBKColor:[UIColor clearColor] 
                                                  withFont:[UIFont fontWithName:@"Helvetica-Bold" size:15.0] 
                                                  withText:@"0"
                                           withShadowColor:[UIColor blackColor] 
                                          withShadowOffSet:CGSizeZero 
                                            withShadowBlur:18.0f 
                                      withInnerShadowColor:[UIColor yellowColor] 
                                     withInnerShadowOffset:CGSizeMake(1.0f, 2.0f) 
                                    withGradientStartColor:[UIColor yellowColor]
                                      withGradientEndColor:[UIColor yellowColor]
                                    withGradientStartPoint:CGPointMake(0.0f, 0.5f) 
                                      withGradientEndPoint:CGPointMake(0.0f, 0.5f)];
    [_coinAnimationLabel setHidden:YES];
    [self.view addSubview:_coinAnimationLabel];
    
    UIImage * img = [UIImage imageNamed:@"moneyIcon"];
    _coinAnimationView = [[UIImageView alloc] initWithImage:img];
    _coinAnimationView.frame = CGRectMake(210.0, 140.0, img.size.width, img.size.height);

    [_coinAnimationView setHidden:YES];
    [self.view addSubview:_coinAnimationView];
    
    _collectAnimationView = [[UIImageView alloc] initWithImage:img];
    _collectAnimationView.frame = CGRectMake(415.0, 110.0, img.size.width, img.size.height);
    [_collectAnimationView setHidden:YES];
    [self.view addSubview:_collectAnimationView];
    
    _timeCountNum = 120;
    _collectCoinTip = [[UILabel alloc] initWithFrame:CGRectMake(380.0, 45.0, 90.0, 30.0)];
    _collectCoinTip.backgroundColor = [UIColor clearColor];
    _collectCoinTip.textAlignment = UITextAlignmentRight;
    _collectCoinTip.font = [UIFont fontWithName:@"Georgia-Bold" size:12.0];
    _collectCoinTip.textColor = [UIColor blackColor];
    _collectCoinTip.text = @"collectin:";
    [utils addShadowColorForLabel:_collectCoinTip];
    [self.view addSubview:_collectCoinTip];
    
    _collectCoinLabel = [[UILabel alloc] initWithFrame:CGRectMake(375.0, 60.0, 90.0, 30.0)];
    _collectCoinLabel.backgroundColor = [UIColor clearColor];
    _collectCoinLabel.textAlignment = UITextAlignmentRight;
    _collectCoinLabel.font = [UIFont fontWithName:@"Georgia-Bold" size:12.0];
    _collectCoinLabel.textColor = [UIColor blackColor];
    _collectCoinLabel.text = [utils getCoinGiftLabelWithInt:_timeCountNum];
    [utils addShadowColorForLabel:_collectCoinLabel];
    [self.view addSubview:_collectCoinLabel];
    
    timeToStart = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(timeCoinLoopAction) userInfo:NULL repeats:YES];
    
    _collectCoinButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _collectCoinButton = [utils setButtonPropertyWithButton:_collectCoinButton
                                                  withFrame:CGRectMake(415.0, 110.0, 55.0, 55.0)
                                                    withTag:0 
                                                withUpImage:[utils getImageFromName:@"collectMoney.png"]
                                              withDownImage:[utils getImageFromName:@"collectMoney.png"]
                                                 withTarget:self 
                                                 withAction:@selector(collectCoinButtonPressed:)];
    [self.view addSubview:_collectCoinButton];
    [utils setCoinButtonShowAnimation:_collectCoinButton];
    [_collectCoinButton setHidden:YES];
    
    UIButton * cameraButton = [UIButton buttonWithType:UIButtonTypeCustom];
    cameraButton = [utils setButtonPropertyWithButton:cameraButton
                                             withFrame:CGRectMake(5.0, 270.0, 50.0, 45.0) 
                                               withTag:0
                                           withUpImage:[utils getImageFromName:@"cameraButton.png"]
                                         withDownImage:[utils getImageFromName:@"cameraButton.png"]
                                            withTarget:self
                                            withAction:@selector(cameraButtonPressed)];
    [self.view addSubview:cameraButton];
    
    UIButton * backButton = [UIButton buttonWithType:UIButtonTypeCustom];
    backButton = [utils setButtonPropertyWithButton:backButton
                                           withFrame:CGRectMake(5.0, 135, 45.0, 40.0)
                                             withTag:BACK_BUTTON_TAG 
                                         withUpImage:[utils getImageFromName:@"homeback.png"]
                                       withDownImage:[utils getImageFromName:@"homeback.png"]
                                          withTarget:self
                                          withAction:@selector(backButtonPressed:)];
    [self.view addSubview:backButton];
    
    _showButton  =  [UIButton buttonWithType:UIButtonTypeCustom];
    _showButton  =  [utils setButtonPropertyWithButton:_showButton
                                             withFrame:CGRectMake(5.0, 190.0, 45.0, 50.0)
                                               withTag:SHOW_BUTTON_STATE_UNSHOW
                                           withUpImage:[utils getImageFromName:@"showButton.png"]
                                         withDownImage:[utils getImageFromName:@"showButton.png"]
                                            withTarget:self
                                            withAction:@selector(showButtonPressed:)];
    [self.view addSubview:_showButton];
    if (![utils retrieveBOOLFromUserDefaultsByKey:GIFT_HAVE_USED]) {
        _giftButton = [UIButton buttonWithType:UIButtonTypeCustom];
        _giftButton = [utils setButtonPropertyWithButton:_giftButton
                                              withFrame:CGRectMake(415, 180, 60, 60) 
                                                withTag:GIFT_BUTTON_TAG_NONE 
                                            withUpImage:[utils getImageFromName:@"giftButton.png"]
                                          withDownImage:[utils getImageFromName:@"giftButton.png"]
                                             withTarget:self 
                                             withAction:@selector(giftButtonPressed:)];
        [self.view addSubview:_giftButton];
        if ([utils retrieveBOOLFromUserDefaultsByKey:GIFT_RATING_SEVER_FLAG]) {
            _giftButton.tag = GIFT_BUTTON_TAG_RATING;
            [_giftButton setHidden:NO];
        }else if([utils retrieveBOOLFromUserDefaultsByKey:GIFT_SHARE_FB_SEVER_FLAG]){
            _giftButton.tag = GIFT_BUTTON_TAG_SHARE_FB;
            [_giftButton setHidden:NO];
        }else{
            _giftButton.tag = GIFT_BUTTON_TAG_NONE;
            [_giftButton setHidden:YES];
        }
    }
    
    if (([utils retrieveBOOLFromUserDefaultsByKey:RECEIVE_AD_SEVER_FLAG])&&(![utils retrieveBOOLFromUserDefaultsByKey:CLOSE_ADS_AFTER_PURCHASE])) {
        _adWhirlView = [AdWhirlView requestAdWhirlViewWithDelegate:self];
        _adWhirlView.frame = CGRectMake(92, 0.0, 320, 50);
        CGAffineTransform transform = CGAffineTransformMakeRotation(0.0);
        [_adWhirlView setTransform:CGAffineTransformScale(transform, 0.8, 0.8)];
        [[_adWhirlView layer] setMasksToBounds:YES];
        [[_adWhirlView layer] setCornerRadius:10.0];
        [[_adWhirlView layer] setBorderWidth:0.0];
        [self.view addSubview:_adWhirlView];
    }
    
    _saveContextButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _saveContextButton = [utils setButtonPropertyWithButton:_saveContextButton 
                                                  withFrame:CGRectMake(365, 260, 50, 55)
                                                    withTag:0
                                                withUpImage:[UIImage imageNamed:@"gallerySaveButtton.png"]
                                              withDownImage:[UIImage imageNamed:@"gallerySaveButtton.png"]
                                                 withTarget:self
                                                 withAction:@selector(saveContextButtonPressed:)];
    [self.view addSubview:_saveContextButton];
    
    //新增物品是否购买
    _buyItemButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _buyItemButton = [utils setButtonPropertyWithButton:_buyItemButton
                                              withFrame:CGRectMake(130, 160, 100, 30) 
                                                withTag:0
                                            withUpImage:[UIImage imageNamed:@"_buy_button.png"] 
                                          withDownImage:[UIImage imageNamed:@"_buy_button.png"] 
                                             withTarget:self 
                                             withAction:@selector(buyItemButtonPressed)];
    [self.view addSubview:_buyItemButton];
    [_buyItemButton setHidden:YES];
    
    _cancelItemButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _cancelItemButton = [utils setButtonPropertyWithButton:_cancelItemButton
                                                 withFrame:CGRectMake(240, 160, 100, 30) 
                                                   withTag:0 
                                               withUpImage:[UIImage imageNamed:@"_cancel_button.png"] 
                                             withDownImage:[UIImage imageNamed:@"_cancel_button.png"] 
                                                withTarget:self 
                                                withAction:@selector(cancelItemButtonPressed)];
    [self.view addSubview:_cancelItemButton];
    [_cancelItemButton setHidden:YES];
}

- (NSString *)adWhirlApplicationKey {
    return AD_WHIRL_ID_IPHONE;
}

- (UIViewController *)viewControllerForPresentingModalView {
    return self;
}

- (void)timeCoinLoopAction{
    if (_timeCountNum == 0) {
        if (_showButton.tag == SHOW_BUTTON_STATE_SHOWING) {
            _timeCountNum = 120;
        }else{
            if (_collectCoinButton.hidden == YES) {
                [_collectCoinButton setHidden:NO];
                if ([utils getSoundLastSave]) {
                    [utils playCafSound:CFSTR("income_ready")];
                }
            }
        }        
    }else{
        _collectCoinLabel.text = [utils getCoinGiftLabelWithInt:_timeCountNum];
        _timeCountNum -= 1; 
    }
}


//item选择数据的初始化以及切换
- (void) initItemDataWithCateIndex:(int)index{
    _currentGroupItems = [[[SQLiteOperation sharedSQLOpt] selectData:[NSString stringWithFormat:@"select itemId, cateId, itemName, itemPic, itemCoin, itemTips, itemOther from tb_item where cateId = '%d'",index] resultColumns:7] retain];
}

//初始化背景容器
- (void) initContainerViewWithIndex:(int)index{
    NSArray * bkImageArray = [NSArray arrayWithObjects:@"designBK_1_iPhone",@"designBK_2_iPhone",@"designBK_3_iPhone",@"designBK_4_iPhone",nil];
    _pickedItemsDict = [[NSMutableDictionary alloc] initWithCapacity:20];

    _containerView = [[UIImageViewBKView alloc] initWithFrame:CGRectMake(0.0, 0.0, 480.0, 320.0)];
    _containerView.userInteractionEnabled = YES;
    [_containerView setDelegate:self];
    NSString * path = [[NSBundle mainBundle] pathForResource:[bkImageArray objectAtIndex:index] ofType:@"png"];
    UIImage * bkImage = [[UIImage alloc] initWithContentsOfFile:path];    
    _containerView.backgroundColor = [UIColor colorWithPatternImage:bkImage];
    _containerView.isBKViewLocked = NO;
    [_containerView setupHandGestureRecognizerWithDraggable:YES 
                                              withPinchable:YES 
                                             withRotateable:NO
                                                withTapable:YES 
                                          withMinPinchScale:1.0 
                                          withMaxPinchScale:1.8];
    [self.view addSubview:_containerView];
    [bkImage release];
    
    
}

- (void) initItemPickOperateView{
    _itemPickOpearteView = [[UIView alloc] initWithFrame:CGRectMake(0.0, 195.0, 480.0, 125.0)];
    _itemPickOpearteView.backgroundColor = [UIColor colorWithPatternImage:[utils getImageFromName:@"scrollBarBKiPhone.png"]];
    [self.view addSubview:_itemPickOpearteView];
    
    //设置_itemPickOpearteView的Tag为0表示隐藏,为1表示半隐藏，为2表示完全展开
    _itemPickOpearteView.tag = ITEM_PICK_VIEW_STATE_SHOW;
    
    _itemScrollView = [[UIScrollView alloc] initWithFrame:CGRectMake(30.0, 45.0, 420.0, 80.0)];
    _itemScrollView.decelerationRate = 0.9;
    
    //设置左边的八个类别按钮
    for (int i = 0; i < 8; i++) {
        UIButton * button = [UIButton buttonWithType:UIButtonTypeCustom];
        button = [utils setButtonPropertyWithButton:button 
                                          withFrame:CGRectMake(10+55*i, -15, 45, 60) 
                                            withTag:10+i 
                                        withUpImage:[utils getImageFromName:[[_cateButtonArray objectAtIndex:i] objectAtIndex:2]] 
                                      withDownImage:[utils getImageFromName:[[_cateButtonArray objectAtIndex:i] objectAtIndex:3]]
                                         withTarget:self 
                                         withAction:@selector(cateButtonPressed:)];
        [_itemPickOpearteView addSubview:button];
    }
    
    //初始化选中的Button背景
    [utils setCateButtonBkImageWithTag:10 withUIView:_itemPickOpearteView withArray:_cateButtonArray];
    
    
    //设置ScrollView
    _itemScrollView = [utils setScrollViewProperty:_itemScrollView withContentSize:CGSizeMake(70*[_currentGroupItems count], 80.0) withDelegate:self];
    
    
    //加载Item
    for (int i = 0; i < [_currentGroupItems count]; i++) {
        scrollItemView_iPhone * view = [[scrollItemView_iPhone alloc] initWithFrame:CGRectMake(0.0+70.0*i, 0.0, 65.0, 80.0)
                                                                   withContentArray:_currentGroupItems
                                                                          withIndex:i 
                                                                         withTarget:self 
                                                                         withAction:@selector(itemPickOpeartion:)];
        //第一次加载半数item
        if (i < [_currentGroupItems count]*0.5) {
            [view loadKitToView];
        }
            
        [_itemScrollView addSubview:view];
        [view release];
    }
    [_itemPickOpearteView addSubview:_itemScrollView];
    //左右滑动Button
    UIButton * leftScrollButton = [UIButton buttonWithType:UIButtonTypeCustom];
    leftScrollButton = [utils setButtonPropertyWithButton:leftScrollButton 
                                                withFrame:CGRectMake(2.0, 70.0, 25.0, 25.0) 
                                                  withTag:0 
                                              withUpImage:[utils getImageFromName:@"leftButton.png"] 
                                            withDownImage:[utils getImageFromName:@"leftButton.png"] 
                                               withTarget:self 
                                               withAction:@selector(leftScrollButtonPressed:)];
    [_itemPickOpearteView addSubview:leftScrollButton];
    UIButton * rightScrollButton = [UIButton buttonWithType:UIButtonTypeCustom];
    rightScrollButton = [utils setButtonPropertyWithButton:rightScrollButton 
                                                 withFrame:CGRectMake(453.0, 70.0, 25.0,25.0) 
                                                   withTag:0 
                                               withUpImage:[utils getImageFromName:@"rightButton.png"] 
                                             withDownImage:[utils getImageFromName:@"rightButton.png"] 
                                                withTarget:self 
                                                withAction:@selector(rightScrollButtonPressed:)];
    [_itemPickOpearteView addSubview:rightScrollButton];
    [_itemPickOpearteView setHidden:YES];
    
    //控制6个操作Button显现的左右两个Button
    //默认先显示右侧的Button
    UIButton  * leftArrowButton = [UIButton buttonWithType:UIButtonTypeCustom];
    leftArrowButton = [utils setButtonPropertyWithButton:leftArrowButton 
                                                withFrame:CGRectMake(450.0, 7, 30, 30) 
                                                  withTag:LEFT_ARROW_BUTTON_TAG
                                              withUpImage:[utils getImageFromName:@"arrow_left.png"] 
                                            withDownImage:[utils getImageFromName:@"arrow_left.png"] 
                                               withTarget:self 
                                              withAction:@selector(leftArrowButtonPress)];
    [_itemPickOpearteView addSubview:leftArrowButton];
    
    UIButton  * rightArrowButton = [UIButton buttonWithType:UIButtonTypeCustom];
    rightArrowButton = [utils setButtonPropertyWithButton:rightArrowButton
                                                withFrame:CGRectMake(170.0, 7, 30, 30) 
                                                  withTag:RIGHT_ARROW_BUTTON_TAG 
                                              withUpImage:[utils getImageFromName:@"arrow_right.png"] 
                                            withDownImage:[utils getImageFromName:@"arrow_right.png"] 
                                               withTarget:self 
                                               withAction:@selector(rightArrowButtonPress)];
    [_itemPickOpearteView addSubview:rightArrowButton];
    [rightArrowButton setHidden:YES];
    [self initOperationButtons];
}

//初始化7个控制按钮
- (void) initOperationButtons{
    _controlButtonSuperView = [[UIView alloc] initWithFrame:CGRectMake(210.0+270.0, 2.0, 270.0, 40.0)];
    _controlButtonSuperView.tag = SIX_CONTROL_BUTTON_SUPERVIEW_STATE_HIDE;
    [_itemPickOpearteView addSubview:_controlButtonSuperView];
    NSArray * operationButtonImage = [NSArray arrayWithObjects:@"zoomInButton.png",@"zoomOutButton.png",@"upButton.png",@"downButton.png",@"refreshButton.png",@"deleteButton.png",@"closeButton.png", nil];
    NSArray * operationPointArray = [NSArray arrayWithObjects:
                                     [NSValue valueWithPointer:@selector(zoomInButtonPressed:)],
                                     [NSValue valueWithPointer:@selector(zoomOutButtonPressed:)],
                                     [NSValue valueWithPointer:@selector(upButtonPressed:)],
                                     [NSValue valueWithPointer:@selector(downButtonPressed:)],
                                     [NSValue valueWithPointer:@selector(refreshButtonPressed:)],
                                     [NSValue valueWithPointer:@selector(deleteButtonPressed:)],
                                     [NSValue valueWithPointer:@selector(closeButtonPressed:)],nil];
    for (int i = 0; i < 6; ++i) {
        UIButton * operationButton = [UIButton buttonWithType:UIButtonTypeCustom];
        operationButton = [utils setButtonPropertyWithButton:operationButton 
                                                   withFrame:CGRectMake(45*i, 0, 40, 40) 
                                                     withTag:1
                                                 withUpImage:[utils getImageFromName:[operationButtonImage objectAtIndex:i]] 
                                               withDownImage:nil 
                                                  withTarget:self 
                                                  withAction:[[operationPointArray objectAtIndex:i] pointerValue]];
        [_controlButtonSuperView addSubview:operationButton];
    }
    UIButton * closePickViewButton = [UIButton buttonWithType:UIButtonTypeCustom];
    closePickViewButton = [utils setButtonPropertyWithButton:closePickViewButton 
                                                    withFrame:CGRectMake(435, 157, 40, 40) 
                                                      withTag:CLOSE_PICK_VIEW_BUTTON_TAG 
                                                  withUpImage:[utils getImageFromName:@"closeButton.png"]
                                                withDownImage:nil
                                                   withTarget:self 
                                                   withAction:@selector(closeButtonPressed:)];
    [self.view addSubview:closePickViewButton];
    [closePickViewButton setHidden:YES];
}

- (void) leftArrowButtonPress{
    for (UIButton * btn in [_itemPickOpearteView subviews]) {
        if ([btn isKindOfClass:[UIButton class]]) {
            if ((btn.tag > 12)&&(btn.tag < 18)) {
                [btn setHidden:YES];
            }
        }
    }
    _controlButtonSuperView.tag = SIX_CONTROL_BUTTON_SUPERVIEW_STATE_SHOW;
    [[utils getButtonFromSuperView:_itemPickOpearteView withTag:RIGHT_ARROW_BUTTON_TAG] setHidden:NO];
    [[utils getButtonFromSuperView:_itemPickOpearteView withTag:LEFT_ARROW_BUTTON_TAG] setHidden:YES];
    [utils rightLeftViewSlide:_controlButtonSuperView withCGFloat:-270.0];
    
    
}

- (void) rightArrowButtonPress{
    [utils rightLeftViewSlide:_controlButtonSuperView withCGFloat:270.0];
    for (UIButton * btn in [_itemPickOpearteView subviews]) {
        if ([btn isKindOfClass:[UIButton class]]) {
            if ((btn.tag > 12)&&(btn.tag < 18)) {
                [btn setHidden:NO];
            }
        }
    }
    _controlButtonSuperView.tag = SIX_CONTROL_BUTTON_SUPERVIEW_STATE_HIDE;
    [[utils getButtonFromSuperView:_itemPickOpearteView withTag:RIGHT_ARROW_BUTTON_TAG] setHidden:YES];
    [[utils getButtonFromSuperView:_itemPickOpearteView withTag:LEFT_ARROW_BUTTON_TAG] setHidden:NO];
}

- (void) leftScrollButtonPressed:(id)sender{
    if (_itemScrollView.contentOffset.x > 240) {
        [_itemScrollView setContentOffset:CGPointMake(_itemScrollView.contentOffset.x-240, 0.0) animated:YES];
    }
    for (scrollItemView_iPhone *subview in _itemScrollView.subviews) {
        if (!subview.isLoaded) {
            if ((subview.tag >= [_currentGroupItems count]*0.5)&&(subview.tag < [_currentGroupItems count]*0.75)) {
                [subview loadKitToView];
            }
        }
    }
}

- (void) rightScrollButtonPressed:(id)sender{
    if (_itemScrollView.contentOffset.x < _itemScrollView.contentSize.width-240) {
        [_itemScrollView setContentOffset:CGPointMake(_itemScrollView.contentOffset.x+240, 0.0) animated:YES];
    }
    for (scrollItemView_iPhone *subview in _itemScrollView.subviews) {
        if (!subview.isLoaded) {
            if (subview.tag >= [_currentGroupItems count]*0.5) {
                [subview loadKitToView];
            }
        }
    }
}
//数据延时加载，减少响应时间
- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView{
    for (scrollItemView_iPhone *subview in _itemScrollView.subviews) {
        if (!subview.isLoaded) {
            if (subview.tag >= [_currentGroupItems count]*0.5) {
                [subview loadKitToView];
            }
        }
    }
}

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView{
    for (scrollItemView_iPhone *subview in _itemScrollView.subviews) {
        if (!subview.isLoaded) {
            if ((subview.tag >= [_currentGroupItems count]*0.75)) {
                [subview loadKitToView];
            }
        }
    }
}
//分类按钮选中时
- (void)cateButtonPressed:(id)sender{
    UIButton * btn = (UIButton *)sender;
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    //显示全部的8个分类
    if (_controlButtonSuperView.tag == SIX_CONTROL_BUTTON_SUPERVIEW_STATE_SHOW) {
        [self rightArrowButtonPress];
    }
    
    
    //之前的数组释放掉，只留下指针
    [_currentGroupItems release];
    [self initItemDataWithCateIndex:(btn.tag-9)];
    [utils setCateButtonBkImageWithTag:btn.tag withUIView:_itemPickOpearteView withArray:_cateButtonArray];
    if (_itemPickOpearteView.tag == ITEM_PICK_VIEW_STATE_HALFHIDE) {
        [utils upDownBoardSlide:_itemPickOpearteView withCGFloat:-_itemPickOpearteView.frame.size.height*0.65];
        [utils upDownBoardSlide:[utils getButtonFromSuperView:self.view withTag:CLOSE_PICK_VIEW_BUTTON_TAG] withCGFloat:-_itemPickOpearteView.frame.size.height*0.65];
        _itemPickOpearteView.tag = ITEM_PICK_VIEW_STATE_SHOW;
    }
    
    for (UIView *subview in _itemScrollView.subviews) {
        [subview removeFromSuperview];
    }
    [_itemScrollView setContentSize:CGSizeMake(70*[_currentGroupItems count], 80.0)];
    [_itemScrollView setContentOffset:CGPointMake(0.0, 0.0)];
    for (int i = 0; i < [_currentGroupItems count]; i++) {
        scrollItemView_iPhone * view = [[scrollItemView_iPhone alloc] initWithFrame:CGRectMake(0.0+70.0*i, 0.0, 65.0, 80.0)
                                                                   withContentArray:_currentGroupItems
                                                                          withIndex:i 
                                                                         withTarget:self 
                                                                         withAction:@selector(itemPickOpeartion:)];
        if ((btn.tag == 17)||(btn.tag == 12)) {
           [view loadKitToView];
        }else{
            if (i < [_currentGroupItems count]*0.5) {
                [view loadKitToView];
            }
        }
        [_itemScrollView addSubview:view];
        [view release];
    }
}

- (void) itemPickOpeartion:(id)sender{
    UIButton * btn = (UIButton *)sender;
    
    [_buyItemButton setHidden:NO];
    [_cancelItemButton setHidden:NO];
    int tag = btn.tag;
    itemPickTag = tag;
    
    if (_lastPickItemViewIndex != 0) {
        [self cancelItemButtonPressed];
    }
    
    
    if ([utils getSoundLastSave]) {
        [utils playCafSound:CFSTR("design")];
    }
    if ([[coinManager sharedCoinManager] coinValue] > [[[_currentGroupItems objectAtIndex:tag] objectAtIndex:4] intValue]) {
        
        [_buyItemButton setHidden:NO];
        [_cancelItemButton setHidden:NO];
        //项目加载在房间界面上
        UIImage * img = [utils getImageFromName:[[_currentGroupItems objectAtIndex:tag] objectAtIndex:2]];
        _currentItemView = [[UIImageViewItemView alloc] initWithFrame:CGRectMake(self.view.frame.size.width*0.5, self.view.frame.size.height*0.3, img.size.width*0.3, img.size.height*0.3)];
        _currentItemView.userInteractionEnabled = YES;
        _currentItemView.image = img;
        //记录对应图片的名字
        _currentItemView.imageName = [[_currentGroupItems objectAtIndex:tag] objectAtIndex:2];
        [_currentItemView setupHandGestureRecognizerWithDraggable:YES
                                                    withPinchable:YES
                                                   withRotateable:NO 
                                                      withTapable:YES
                                                withMinPinchScale:0.5
                                                withMaxPinchScale:1.5];
        [_currentItemView setDelegate:self];
        [_currentItemView setPickUniqueNumber:_pickUniqueIndex];
        [_currentItemView setPickViewCoin:[[[_currentGroupItems objectAtIndex:tag] objectAtIndex:4] intValue]];
        [_currentItemView.layer setName:[NSString stringWithFormat:@"%d",_pickUniqueIndex]];
        [_containerView addSubview:_currentItemView];
        _lastPickItemViewIndex = _pickUniqueIndex;
        //清除全部的选中指示，将当期购买的设为选中
        [self cleanAllShadowOfItems];
        [utils addShadowColor:_currentItemView];
        [_pickedItemsDict setObject:_currentItemView forKey:[NSString stringWithFormat:@"%d",_pickUniqueIndex]];
        [_currentItemView release];
        _pickUniqueIndex = _pickUniqueIndex + 1;
    }else{
        //这个时候金币不足了，应该有个AlertView
        UIAlertView * alertView = [[UIAlertView alloc] initWithTitle:@"Hint"
                                                             message:@"Need more money"
                                                            delegate:self
                                                   cancelButtonTitle:@"OK" 
                                                   otherButtonTitles:@"Get money",nil];
        alertView.tag = 2;
        [alertView show];
        [alertView release];
    }
}

- (void) buyItemButtonPressed{
    //购买项目后金币的变化与对应的动画展示
    [[coinManager sharedCoinManager] minusCoinValueWithChangedValue:[[[_currentGroupItems objectAtIndex:itemPickTag] objectAtIndex:4] intValue]];
    [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
    [utils setCoinChangeAnimateWithSign:modelCoinMinus withLable:_coinAnimationLabel withChange:[[[_currentGroupItems objectAtIndex:itemPickTag] objectAtIndex:4] intValue] withImageView:_coinAnimationView withDelegate:self];
    [self roomValueCalculateWithSign:modelCoinPlus withChange:[[[_currentGroupItems objectAtIndex:itemPickTag] objectAtIndex:4] intValue]];
    
    [_buyItemButton setHidden:YES];
    [_cancelItemButton setHidden:YES];
    _lastPickItemViewIndex = 0;
}

- (void) cancelItemButtonPressed{
    UIImageViewItemView * view = [_pickedItemsDict objectForKey:[NSString stringWithFormat:@"%d",_lastPickItemViewIndex]];
    [_pickedItemsDict removeObjectForKey:[NSString stringWithFormat:@"%d",_lastPickItemViewIndex]];
    [view removeFromSuperview];
    [_buyItemButton setHidden:YES];
    [_cancelItemButton setHidden:YES];
    _lastPickItemViewIndex = 0;
    _currentItemView = nil;
}

- (void) roomValueCalculateWithSign:(ModelCoinViewChangeDirection)direction withChange:(int)value{
    int key = [[coinManager sharedCoinManager] roomValue] / 1000;
    float keyNum = 0.0;
    switch (key) {
        case 0:
            keyNum = 0.50;
            break;
        case 1:
            keyNum = 0.55;
            break;
        case 2:
            keyNum = 0.60; 
            break;
        case 3:
            keyNum = 0.70;
            break;
        case 4:
            keyNum = 0.75;
            break;
        case 5:
            keyNum = 0.80;
            break;
        case 6:
            keyNum = 0.95;
            break;
        case 7:
            keyNum = 1.10;
            break;
        case 8:
            keyNum = 1.15;
            break;
        default:
            keyNum = 1.00;
            break;
    }
    switch (direction) {
        case modelCoinMinus:
            [[coinManager sharedCoinManager] minusRoomValueWithChangedValue:value*keyNum];
            break;
        case modelCoinPlus:
            [[coinManager sharedCoinManager] plusRoomValueWithChangedValue:value*keyNum];
            break;
        default:
            break;
    }
    [_roomValueLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] roomValue]]];
}

- (void) cameraButtonPressed{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("takePic")];
    }
    
    if (_lastPickItemViewIndex != 0) {
        [self cancelItemButtonPressed];
    }
    
    UIView * cameraContainer = [[UIView alloc] initWithFrame:CGRectMake(25.0, 30.0, 430.0, 260.0)];
    cameraContainer.backgroundColor = [UIColor colorWithRed:1.0 green:0.90 blue:0.90 alpha:1.0];
    [self.view addSubview:cameraContainer];
    [cameraContainer release];
    
    UIImageView * cameraPic = [[UIImageView alloc] initWithFrame:CGRectMake(15.0, 20.0, 330.0, 220.0)];
    cameraPic.image = [utils getCameraImageFromView:_containerView];    
    [cameraContainer addSubview:cameraPic];
    [cameraPic release];
    
    UIButton * closeCameraButton = [UIButton buttonWithType:UIButtonTypeCustom];
    closeCameraButton = [utils setButtonPropertyWithButton:closeCameraButton
                                                 withFrame:CGRectMake(390.0, -10.0, 50.0, 50.0)
                                                   withTag:0 
                                               withUpImage:[utils getImageFromName:@"backButton.png"]
                                             withDownImage:[utils getImageFromName:@"backButton.png"]
                                                withTarget:cameraContainer
                                                withAction:@selector(removeFromSuperview)];
    [cameraContainer addSubview:closeCameraButton];
    
    //360.0, 20.0
    UIButton * saveCameraButton = [UIButton buttonWithType:UIButtonTypeCustom];
    saveCameraButton = [utils setButtonPropertyWithButton:saveCameraButton 
                                                withFrame:CGRectMake(360.0, 30.0, 45.0, 50.0)
                                                  withTag:0 
                                              withUpImage:[utils getImageFromName:@"albumSave.png"]
                                            withDownImage:[utils getImageFromName:@"albumSave.png"]
                                               withTarget:self 
                                               withAction:@selector(saveCameraButtonPressed)];
    [cameraContainer addSubview:saveCameraButton];
    
    UIButton * shareCameraButton = [UIButton buttonWithType:UIButtonTypeCustom];
    shareCameraButton = [utils setButtonPropertyWithButton:shareCameraButton 
                                                 withFrame:CGRectMake(360.0, 100.0, 45.0, 50.0)
                                                   withTag:0 
                                               withUpImage:[utils getImageFromName:@"facebookButton.png"]
                                             withDownImage:[utils getImageFromName:@"facebookButton.png"]
                                                withTarget:self 
                                                withAction:@selector(shareCameraButtonPressed:)];
    [cameraContainer addSubview:shareCameraButton];
    
    UIButton * sellCameraButton = [UIButton buttonWithType:UIButtonTypeCustom];
    sellCameraButton = [utils setButtonPropertyWithButton:sellCameraButton 
                                                withFrame:CGRectMake(360.0, 170.0, 45.0, 50.0)
                                                  withTag:0 
                                              withUpImage:[utils getImageFromName:@"sellBagButton.png"]
                                            withDownImage:[utils getImageFromName:@"sellBagButton.png"]
                                               withTarget:self 
                                               withAction:@selector(sellCameraButtonPressed:)];
    [cameraContainer addSubview:sellCameraButton];
}

//保存相册
- (void)saveCameraButtonPressed{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    [utils saveImage:[utils getCameraImageFromView:_containerView]];
}

//分享
- (void)shareCameraButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(shareToFBComplete) name:@"Share_To_FB_Complete" object:nil];
    
    NSString * title = @"\"It is my work!\"";
    NSString * name = @"Princess Room Designer";
    NSString * url = @"http://itunes.apple.com/app/id540110132";
    NSString * titleString = [[NSString alloc] initWithFormat:@"%@ \nGet %@ - It's Free! %@", title,name,url];
    SHKItem  * itemToShare = [SHKItem image:[utils getCameraImageFromView:_containerView] title:titleString];
    [SHKFacebook shareItem:itemToShare];
}

//保存当前场景
- (void)saveContextButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    
    if (_lastPickItemViewIndex != 0) {
        [self cancelItemButtonPressed];
    }
    if (_bKId != 0) {
        [utils removeImageItemFromDocumets:[NSString stringWithFormat:@"%d.png",_bKId]];
        NSString * sqlString = [NSString stringWithFormat:@"delete from tb_saveBK where bKId = '%d'",_bKId];
        NSString * sqlStringItem = [NSString stringWithFormat:@"delete from tb_saveItem where itemBk  = '%d'",_bKId];
        if ([[SQLiteOperation sharedSQLOpt] dealData:sqlString paramArray:nil]) {
            [[SQLiteOperation sharedSQLOpt] dealData:sqlStringItem paramArray:nil];
        }
    }
    
    int readTopId = [utils retrieveIntegerFromUserDefaultsByKey:TB_SAVE_BK_BKID_NUM] + 1;
    NSLog(@"readTopId %d",readTopId);
    NSArray * array = [NSArray arrayWithObjects:[NSString stringWithFormat:@"%d",readTopId],[NSString stringWithFormat:@"%d",pointBKImage],[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] roomValue]],[NSString stringWithFormat:@"%d.png",readTopId], @"0",nil];
    [utils saveContextImage:readTopId withView:_containerView];
    
    NSString * sql = @"insert into tb_saveBK values (?,?,?,?,?)";
    if ([[SQLiteOperation sharedSQLOpt] insertTbSaveBk:sql paramArray:array]) {
        [utils saveIntegerToUserDefaults:readTopId forKey:TB_SAVE_BK_BKID_NUM];
    }
    NSArray * keys = [_pickedItemsDict allKeys];
    if ([keys count] > 0) {
        [[SQLiteOperation sharedSQLOpt] insertTbSaveItem:_pickedItemsDict withBkIdInt:readTopId];
    }
    _bKId = readTopId;
    roomAppDelegate * appDelegate   = (roomAppDelegate *)[[UIApplication sharedApplication] delegate]; 
    appDelegate.reloadDataFromDB = YES;
    [[SHKActivityIndicator currentIndicator] displayCompleted:@"Saved!"];
}

- (void)shareToFBComplete{
    if ((![utils retrieveBOOLFromUserDefaultsByKey:GIFT_HAVE_USED])&&([utils retrieveBOOLFromUserDefaultsByKey:GIFT_SHARE_FB_SEVER_FLAG])) {
        [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:1500];
        [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
        [utils saveBOOLToUserDefaults:YES forKey:GIFT_HAVE_USED];
        if (_giftButton != nil) {
            [_giftButton removeFromSuperview];
            _giftButton = nil;
        }
        
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Congratulations!" message:@"You've successfully get 1500 Cash!" delegate:self  cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alert show];
        [alert release];
    }
}

- (void)giftButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    
    if (_giftButton.tag == GIFT_BUTTON_TAG_RATING) {
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(rateUsCompleteHideBtn) name:@"Rate_Us_Complete" object:nil];
        _giftBoardView = [[giftBoardView_iPhone alloc] initWithFrame:CGRectMake(50.0, 30.0, 380.0, 260.0)];
        _giftBoardView.userInteractionEnabled = YES;
        _giftBoardView.target = self;
        [self.view addSubview:_giftBoardView];
        [_giftBoardView release];
        
    }
    if (_giftButton.tag == GIFT_BUTTON_TAG_SHARE_FB) {
        [self cameraButtonPressed];
        iToast  *toast = nil;
        toast = [iToast makeText:@"Share your work to facebook to earn 1500 cash free."];
        [toast setDuration:4000];
        [toast setGravity:iToastGravityBottom offsetLeft:50 offsetTop:150];
        [toast show];
    }
}

- (void)rateUsCompleteHideBtn{
    [_giftButton setHidden:YES];
    [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
}
//mail sending delegate
- (void)mailComposeController:(MFMailComposeViewController*)controller  
          didFinishWithResult:(MFMailComposeResult)result  
                        error:(NSError*)error {
    switch (result)
    {
        case MFMailComposeResultCancelled:
            //[[SHKActivityIndicator currentIndicator] displayCompleted:@"Email canceled"];
            break;
        case MFMailComposeResultSaved:
            //[[SHKActivityIndicator currentIndicator] displayCompleted:@"Email saved"];
            break;
        case MFMailComposeResultSent:
            [[SHKActivityIndicator currentIndicator] displayCompleted:@"Sent!"];
            break;
        case MFMailComposeResultFailed:
            [[SHKActivityIndicator currentIndicator] displayCompleted:@"Failed!"];
            break;
        default:
            [[SHKActivityIndicator currentIndicator] displayCompleted:@"Failed!"];
            break;
    }
    [self dismissModalViewControllerAnimated:YES]; 
}

- (void) showButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    if (_showButton.tag == SHOW_BUTTON_STATE_UNSHOW) {
        _containerView.transform = CGAffineTransformIdentity;
        _containerView.frame = CGRectMake(0.0, 0.0, 480.0, 320.0);
        [[utils getButtonFromSuperView:self.view withTag:CLOSE_PICK_VIEW_BUTTON_TAG] setHidden:YES];
        [_itemPickOpearteView setHidden:YES];
        [_designButton setHidden:YES];

        [_lockBKButton setHidden:YES];
        [_coinShowLabel setHidden:YES];
        [[utils getButtonFromSuperView:self.view withTag:COIN_SHOW_BUTTON_TAG] setHidden:YES];
        [[utils getButtonFromSuperView:self.view withTag:ROOM_VALUE_BUTTON_TAG] setHidden:YES];
        [[utils getButtonFromSuperView:self.view withTag:BACK_BUTTON_TAG] setHidden:YES];
        [_roomValueLabel setHidden:YES];
        [_collectCoinTip setHidden:YES];
        [_collectCoinLabel setHidden:YES];
        [_collectCoinButton setHidden:YES];
        [_giftButton setHidden:YES];
        
        _showButton.tag = SHOW_BUTTON_STATE_SHOWING;
        
    }else{
        [_designButton setHidden:NO];       
        [_lockBKButton setHidden:NO];
        
        
        [_coinShowLabel setHidden:NO];
        [[utils getButtonFromSuperView:self.view withTag:COIN_SHOW_BUTTON_TAG] setHidden:NO];
        [[utils getButtonFromSuperView:self.view withTag:ROOM_VALUE_BUTTON_TAG] setHidden:NO];
        [[utils getButtonFromSuperView:self.view withTag:BACK_BUTTON_TAG] setHidden:NO];
        [_roomValueLabel setHidden:NO];
        [_collectCoinTip setHidden:NO];
        [_collectCoinLabel setHidden:NO];
        
        if (![utils retrieveBOOLFromUserDefaultsByKey:GIFT_HAVE_USED]) {
            if ([utils retrieveBOOLFromUserDefaultsByKey:GIFT_RATING_SEVER_FLAG]||[utils retrieveBOOLFromUserDefaultsByKey:GIFT_SHARE_FB_SEVER_FLAG]) {
                [_giftButton setHidden:NO];
            }
        }
        
        _showButton.tag = SHOW_BUTTON_STATE_UNSHOW;
    }
}

- (void)backButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    /*
    if ([[coinManager sharedCoinManager] roomValue] > 0) {
        [[coinManager sharedCoinManager] saveRoomValue];
        //是否在此进行housevalue的转换。
    }*/
    [[coinManager sharedCoinManager] saveRoomValue];
    [[coinManager sharedCoinManager] saveCoinValue];
    UIAlertView * alert = [[UIAlertView alloc] initWithTitle:@"Hint" 
                                                     message:@"Save the work and back to main page. Are you sure?" 
                                                    delegate:self
                                           cancelButtonTitle:@"Cancel"
                                           otherButtonTitles:@"OK", nil];
    alert.tag = 3;
    [alert show];
    [alert release];
    
}

- (void) collectCoinButtonPressed:(id)sender{
    //送钱,动画和效果,一次送钱80
    
    //这一组动画要不要加呢
    //[utils setCoinChangeAnimateWithSign:modelCoinPlus withLable:_coinAnimationLabel withChange:sendMoney*10 withImageView:_coinAnimationView withDelegate:self];
    if ([utils getSoundLastSave]) {
        [utils playCafSound:CFSTR("collect")];
    }
    [_collectCoinButton setHidden:YES];
    
    [_collectAnimationView setHidden:NO];
    [utils collectCoinImageAnimation:_collectAnimationView withDelegate:self];
    _timeCountNum = 120;
}

- (void) designButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playCafSound:CFSTR("design")];
    }
    [_designButton setHidden:YES];
    [_itemPickOpearteView setHidden:NO];
    [[utils getButtonFromSuperView:self.view withTag:CLOSE_PICK_VIEW_BUTTON_TAG] setHidden:NO];
    if (_itemPickOpearteView.tag == ITEM_PICK_VIEW_STATE_HALFHIDE) {
        [utils upDownBoardSlide:_itemPickOpearteView withCGFloat:-_itemPickOpearteView.frame.size.height*0.65];
        [utils upDownBoardSlide:[utils getButtonFromSuperView:self.view withTag:CLOSE_PICK_VIEW_BUTTON_TAG] withCGFloat:-_itemPickOpearteView.frame.size.height*0.65];
        _itemPickOpearteView.tag = ITEM_PICK_VIEW_STATE_SHOW;
    }
    
}


- (void) lockBKButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    iToast  *toast = nil;
    if (_lockBKButton.tag == LOCK_BK_BUTTON_STATE_UNLOCKED) {
        //固定背景
        toast = [iToast makeText:@"Background of room is locked. Tap the 'unlock' button to unlock."];
        [_containerView setupHandGestureRecognizerWithDraggable:NO 
                                                  withPinchable:YES 
                                                 withRotateable:NO
                                                    withTapable:YES 
                                              withMinPinchScale:1.0 
                                              withMaxPinchScale:1.8];
        [_lockBKButton setBackgroundImage:[utils getImageFromName:@"lockButton.png"] forState:UIControlStateNormal];
        _lockBKButton.tag = LOCK_BK_BUTTON_STATE_LOCKED;
        [_containerView setIsBKViewLocked:YES];
        [toast setDuration:2000];
        [toast setGravity:iToastGravityBottom offsetLeft:50 offsetTop:210];
        [toast show];
    }else{
        //背景激活，可以拖拽
        toast = [iToast makeText:@"Room background is unlocked."];
        [_containerView setupHandGestureRecognizerWithDraggable:YES 
                                                  withPinchable:YES 
                                                 withRotateable:NO
                                                    withTapable:YES 
                                              withMinPinchScale:1.0 
                                              withMaxPinchScale:1.8];
        [_lockBKButton setBackgroundImage:[utils getImageFromName:@"unlockButton.png"] forState:UIControlStateNormal];
        _lockBKButton.tag = LOCK_BK_BUTTON_STATE_UNLOCKED;
        [_containerView setIsBKViewLocked:NO];
        [toast setDuration:2000];
        [toast setGravity:iToastGravityBottom offsetLeft:50 offsetTop:210];
        [toast show];
    }
}

- (void) setControllPoint:(UIImageViewItemView *)point{
    [self cleanAllShadowOfItems];
    _currentItemView = point;
    [utils addShadowColor:_currentItemView];
    
    if (_controlButtonSuperView.tag == SIX_CONTROL_BUTTON_SUPERVIEW_STATE_HIDE) {
        [self leftArrowButtonPress];
    }
    /*
    if (_lockBKButton.tag == LOCK_BK_BUTTON_STATE_UNLOCKED) {
        [_lockBKButton setHidden:YES];
    }else{
        [_lockBKButton setHidden:NO];
    }
     */
}

- (void) cleanAllShadowOfItems{
    NSArray * keys = [_pickedItemsDict allKeys];
    for (int i = 0; i < [keys count]; ++i) {
        UIImageViewItemView * v = [_pickedItemsDict objectForKey:[keys objectAtIndex:i]];
        if (v.isHighLighted == YES) {
            [utils removeShadowColor:v];
        }
    }
}

- (void) isPickViewHalfHide{
    if (_itemPickOpearteView.tag == ITEM_PICK_VIEW_STATE_SHOW) {
        [utils upDownBoardSlide:_itemPickOpearteView withCGFloat:_itemPickOpearteView.frame.size.height*0.65];
        [utils upDownBoardSlide:[utils getButtonFromSuperView:self.view withTag:CLOSE_PICK_VIEW_BUTTON_TAG] withCGFloat:_itemPickOpearteView.frame.size.height*0.65];
        _itemPickOpearteView.tag = ITEM_PICK_VIEW_STATE_HALFHIDE;
    }
}


- (void) zoomInButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    [_currentItemView zoomWithValue:1.1];
}

- (void) zoomOutButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    [_currentItemView zoomWithValue:0.9];
}
- (void) upButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    [_containerView bringSubviewToFront:_currentItemView];
}
- (void) downButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    [_containerView sendSubviewToBack:_currentItemView];
}
- (void) refreshButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    CGFloat currentScale = [[_currentItemView.layer valueForKeyPath:@"transform.scale"] floatValue];
    /*
    NSLog(@"currentScale.a %f",_currentItemView.transform.a);
    NSLog(@"currentScale.b %f",_currentItemView.transform.b);
    NSLog(@"currentScale.c %f",_currentItemView.transform.c);
    NSLog(@"currentScale.d %f",_currentItemView.transform.d);
    NSLog(@"currentScale.tx %f",_currentItemView.transform.tx);
    NSLog(@"currentScale.ty %f",_currentItemView.transform.ty);
    */
    if (_currentItemView.isTransformGreaterThanZero == YES) {
        _currentItemView.transform = CGAffineTransformMakeScale(0-currentScale, currentScale);
        _currentItemView.isTransformGreaterThanZero = NO;
    }else{
        _currentItemView.transform = CGAffineTransformMakeScale(0-currentScale, 0-currentScale);
        _currentItemView.isTransformGreaterThanZero = YES;
    }
}
- (void) deleteButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    
    if (_currentItemView) {
        
        //卖掉项目后金币的变化与对应的动画展示
        if (_currentItemView.pickUniqueNumber != _lastPickItemViewIndex) {
            if ([[coinManager sharedCoinManager] roomValue] - _currentItemView.pickViewCoin*0.8 >= 0) {
                [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:_currentItemView.pickViewCoin*0.5];
                [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
                [utils setCoinChangeAnimateWithSign:modelCoinPlus withLable:_coinAnimationLabel withChange:_currentItemView.pickViewCoin*0.5 withImageView:_coinAnimationView withDelegate:self];
                [self roomValueCalculateWithSign:modelCoinMinus withChange:_currentItemView.pickViewCoin*0.8];
            }else{
                [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:_currentItemView.pickViewCoin*0.5];
                [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
                [utils setCoinChangeAnimateWithSign:modelCoinPlus withLable:_coinAnimationLabel withChange:_currentItemView.pickViewCoin*0.5 withImageView:_coinAnimationView withDelegate:self];
                [self roomValueCalculateWithSign:modelCoinMinus withChange:[[coinManager sharedCoinManager] roomValue]];
            }
        }else{
            [_buyItemButton setHidden:YES];
            [_cancelItemButton setHidden:YES];
            _lastPickItemViewIndex = 0;
        }
        [_pickedItemsDict removeObjectForKey:[NSString stringWithFormat:@"%d",_currentItemView.pickUniqueNumber]];
        [_currentItemView removeFromSuperview];
        
    }
    
    _currentItemView = nil; 
    
}
- (void) closeButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    [_designButton setHidden:NO];
    [[utils getButtonFromSuperView:self.view withTag:CLOSE_PICK_VIEW_BUTTON_TAG] setHidden:YES];
    [_itemPickOpearteView setHidden:YES];
}

//IAP
- (void) coinShowButtonPressed{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    UIImageView * purchaseView = [[UIImageView alloc] initWithFrame:CGRectMake(65.0, 50.0, 350.0, 220.0)];
    purchaseView.image = [utils getImageFromName:@"purchaseBoard.png"];
    purchaseView.userInteractionEnabled = YES;
    [self.view addSubview:purchaseView];
    [purchaseView release];
    int x,y;
    for (int i = 0; i < 8; ++i) {
        x = i / 2;
        y = i % 2;
        UIButton * btn = [UIButton buttonWithType:UIButtonTypeCustom];
        btn  = [utils setButtonPropertyWithButton:btn
                                        withFrame:CGRectMake(95 + 165.0*y, 15 + 39*x, 70, 30) 
                                          withTag:i 
                                      withUpImage:[utils getImageFromName:@"buybutton.png"] 
                                    withDownImage:[utils getImageFromName:@"buybutton.png"] 
                                       withTarget:self 
                                       withAction:@selector(purchaseButtonPressed:)];
        [purchaseView addSubview:btn];
    }
    UIButton * purchaseCloseButton = [UIButton buttonWithType:UIButtonTypeCustom];
    purchaseCloseButton = [utils setButtonPropertyWithButton:purchaseCloseButton 
                                                   withFrame:CGRectMake(310.0, -10.0, 45.0, 45.0)
                                                     withTag:0 
                                                 withUpImage:[utils getImageFromName:@"backButton.png"] 
                                               withDownImage:[utils getImageFromName:@"backButton.png"] 
                                                  withTarget:purchaseView
                                                  withAction:@selector(removeFromSuperview)];
    [purchaseView addSubview:purchaseCloseButton];
}

//购买IAP
- (void)purchaseButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    UIButton * btn = (UIButton *)sender;
    int key = [[[[_purchaseIdArray objectAtIndex:btn.tag] objectAtIndex:1] substringFromIndex:32] intValue];
   
    if ([utils isNetworkOK]) {
        [[SHKActivityIndicator currentIndicator] displayActivity:SHKLocalizedString(@"Purchasing")];
        [[MKStoreManager sharedManager] buyFeature:[[_purchaseIdArray objectAtIndex:btn.tag] objectAtIndex:1]
                                        onComplete:^(NSString* purchasedFeature)
         {
             [[SHKActivityIndicator currentIndicator] displayCompleted:SHKLocalizedString(@"Success!")];
             //金币购买增加
             [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:key];
             [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
             [utils setCoinChangeAnimateWithSign:modelCoinMinus withLable:_coinAnimationLabel withChange:key withImageView:_coinAnimationView withDelegate:self];
             //监测去广告
            #warning remeber this place
             [utils saveBOOLToUserDefaults:YES forKey:CLOSE_ADS_AFTER_PURCHASE];
             if (_adWhirlView != nil) {
                 [_adWhirlView removeFromSuperview];
                 _adWhirlView = nil;
             }
             //购买成功，通知
             NSString * noticeString = [NSString stringWithFormat:@"You've successfully get %d Cash!",key];
             UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Congratulations!" message:noticeString delegate:self  cancelButtonTitle:@"OK" otherButtonTitles:nil];
             [alert show];
             [alert release];
         }
                                       onCancelled:^
         {
             [[SHKActivityIndicator currentIndicator] displayCompleted:SHKLocalizedString(@"Cancelled!")];
             NSLog(@"User Cancelled Transaction");
         }];
    }
    
}

- (void)sellCameraButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playCafSound:CFSTR("sell")];
    }
    NSString * hintString = [NSString stringWithFormat:@"Sell the work for $%d",[[coinManager sharedCoinManager] roomValue]];
    UIAlertView * alertView = [[UIAlertView alloc] initWithTitle:@"Hint"
                                                         message:hintString
                                                        delegate:self
                                               cancelButtonTitle:@"NO, don't sell now!"
                                               otherButtonTitles:@"YES, I need money!", nil];
    alertView.tag = 1;
    [alertView show];
    [alertView release];
}
- (void) roomValueButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    iToast * toast;
    toast = [iToast makeText:@"Tap the camera button, you can sell your work to get more money."];
    [toast setDuration:3000];
    [toast setGravity:iToastGravityBottom offsetLeft:50 offsetTop:210];
    [toast show];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    if (alertView.tag == 1) {
        switch (buttonIndex) {
            case 0:
                break;
            case 1:    
                [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:[[coinManager sharedCoinManager] roomValue]];
                [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
                [utils setCoinChangeAnimateWithSign:modelCoinPlus withLable:_coinAnimationLabel withChange:[[coinManager sharedCoinManager] roomValue] withImageView:_coinAnimationView withDelegate:self];
                [[coinManager sharedCoinManager] setRoomValue:0];
                [[coinManager sharedCoinManager] saveRoomValue];
                [_roomValueLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] roomValue]]];
                break;
            default:
                break;
        }
    }else if (alertView.tag == 2){
        iToast * toast;
        switch (buttonIndex) {
            case 0:
                toast = [iToast makeText:@"You can get some cash every 2 minutes as bonus or exchange home value into cash."];
                [toast setDuration:4000];
                [toast setGravity:iToastGravityBottom offsetLeft:50 offsetTop:210];
                [toast show];
                break;
            case 1:
                //IAP
                [self coinShowButtonPressed];
            default:
                break;
        } 
    }else{
        switch (buttonIndex) {
            case 0:                
                break;
            case 1:
                if (timeToStart) {
                    [timeToStart invalidate];
                    timeToStart = nil;
                }
                if (_bKId > 0) {
                    [[coinManager sharedCoinManager] setRoomValue:0];
                    [[coinManager sharedCoinManager] saveRoomValue];
                }else{
                    if ([[coinManager sharedCoinManager] roomValue] > 0) {
                        
                        int readTopId = [utils retrieveIntegerFromUserDefaultsByKey:TB_SAVE_BK_BKID_NUM] + 1;
                        NSLog(@"readTopId %d",readTopId);
                        NSArray * array = [NSArray arrayWithObjects:[NSString stringWithFormat:@"%d",readTopId],[NSString stringWithFormat:@"%d",pointBKImage],[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] roomValue]],[NSString stringWithFormat:@"%d.png",readTopId], @"0",nil];
                        [utils saveContextImage:readTopId withView:_containerView];
                        
                        NSString * sql = @"insert into tb_saveBK values (?,?,?,?,?)";
                        if ([[SQLiteOperation sharedSQLOpt] insertTbSaveBk:sql paramArray:array]) {
                            [utils saveIntegerToUserDefaults:readTopId forKey:TB_SAVE_BK_BKID_NUM];
                        }
                        NSArray * keys = [_pickedItemsDict allKeys];
                        if ([keys count] > 0) {
                            [[SQLiteOperation sharedSQLOpt] insertTbSaveItem:_pickedItemsDict withBkIdInt:readTopId];
                        }
                        _bKId = readTopId;
                        
                        [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:[[coinManager sharedCoinManager] roomValue]];
                        [[coinManager sharedCoinManager] setRoomValue:0];
                        [[coinManager sharedCoinManager] saveRoomValue];
                    }
                }
                [self.navigationController popViewControllerAnimated:YES];
            default:
                break;
        }
    }
}
- (void)coinAnimationStop:(NSString *)animation finish:(BOOL)flag context:(void *)context
{
    _coinAnimationView.frame = CGRectMake(210.0, 140.0, 20.5, 23.0);
    _coinAnimationLabel.frame = CGRectMake(160.0, 140.0, 105.0, 30.0);
    [_coinAnimationLabel setHidden:YES];
    [_coinAnimationView setHidden:YES];
}
//收集金币的动画执行完后增加金币
- (void)collectAnimationStop:(NSString *)animation finish:(BOOL)flag context:(void *)context{
    int sendMoney = 0;
    if ([[coinManager sharedCoinManager] coinValue] < 200) {
        sendMoney = arc4random()%10 + 30;
    }else{
        sendMoney = arc4random()%10 + 15;
    }
    [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:sendMoney*10];
    [_coinShowLabel setText:[NSString stringWithFormat:@"%d",[[coinManager sharedCoinManager] coinValue]]];
    _collectAnimationView.frame = CGRectMake(415.0, 110.0, 20.5, 23.0);
    [_collectAnimationView setHidden:YES];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {    
    if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight) {
        return YES;
    }else{
        return NO;
    }
}


- (void) setCurrentPointView{
    _containerView.currentItemView = _currentItemView;
}

//指针更新给容器
- (void) updateAllItemView{
    _containerView.allItemDict = _pickedItemsDict;
}

- (void) setLockButtonAnimate{
    _lockBKButton.transform = CGAffineTransformMakeScale(1.0, 1.0);
    [utils setLockButtonShowAnimation:_lockBKButton];
}


- (void)dealloc{
    [_containerView removeFromSuperview];
    [_pickedItemsDict removeAllObjects];
    [_pickedItemsDict release];
    [_cateButtonArray release];
    [_purchaseIdArray release];
    [_collectCoinTip release];
    [_collectCoinLabel release];
    [_coinAnimationView release];
    [_coinAnimationLabel release];
    [_collectAnimationView release];
    [_coinShowLabel release];
    [_roomValueLabel release];
    [_currentGroupItems release];
    [_containerView release];
    [_itemPickOpearteView release];
    [_itemScrollView release];
    [super dealloc];
}
@end
