//
//  roomSelectController_iPhone.m
//  room
//
//  Created by mac on 12-6-15.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "roomSelectController_iPhone.h"
#import "roomDesignController_iPhone.h"

@implementation roomSelectController_iPhone


- (id)init{
    self = [super init];
    if (self) {
        
        UIImageView * bkImageView = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 480.0, 320.0)];
        
        NSString * path = [[NSBundle mainBundle] pathForResource:@"mainBKiPhone" ofType:@"png"];
        UIImage * bkImage = [[UIImage alloc] initWithContentsOfFile:path];
        bkImageView.image = bkImage;
        [self.view addSubview:bkImageView];
        [bkImage release];
        
        [bkImageView release];
        [self initButtons];
        [[coinManager sharedCoinManager] getInitHealthValueAndCoin];
    }
    NSString *musicFilePath = [[NSBundle mainBundle] pathForResource:@"background.mp3" ofType:nil];
    _bgMusicPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:[NSURL fileURLWithPath:musicFilePath] error:nil];
    [_bgMusicPlayer prepareToPlay];
    [_bgMusicPlayer setVolume:1]; 
    [_bgMusicPlayer setNumberOfLoops:-1];
    if ([utils getbgMusicLastSave]){        
        [_bgMusicPlayer play];
    }
    _galleryArray = [[[SQLiteOperation sharedSQLOpt] selectData:@"select bKId,bKImageName,bKHomeValue,bKIconName,bKOther from tb_saveBK" resultColumns:5] retain]; 
    _btnId = 0;
    roomAppDelegate * appDelegate   = (roomAppDelegate *)[[UIApplication sharedApplication] delegate];
    appDelegate.reloadDataFromDB = NO;
    [self initGallaryView];
    return self;
}

- (void) initGallaryView{
    
    _galleryView = [[UIView alloc] initWithFrame:CGRectMake(480, 0.0, 100.0, 320.0)];
    [self.view addSubview:_galleryView];
    
    _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 10, 100.0, 300.0) style:UITableViewStylePlain];
    _tableView.backgroundView.backgroundColor = [UIColor clearColor];
    _tableView.delegate = self;
    _tableView.dataSource = self;
    [_galleryView addSubview:_tableView];
    
    UIButton * closeGalleryBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    closeGalleryBtn = [utils setButtonPropertyWithButton:closeGalleryBtn 
                                               withFrame:CGRectMake(-5, 0, 25.0, 25.0) 
                                                 withTag:0 
                                             withUpImage:[utils getImageFromName:@"closeGalleryView.png"] 
                                           withDownImage:[utils getImageFromName:@"closeGalleryView.png"]
                                              withTarget:self 
                                              withAction:@selector(closeGalleryBtn:)];
    [_galleryView addSubview:closeGalleryBtn];
}

- (void)viewWillAppear:(BOOL)animated{
    if (_galleryView.center.x < 480.0 ) {
        [utils rightLeftViewSlide:_galleryView withCGFloat:100.0];
    }
}

- (void)closeGalleryBtn:(id)sender{
    [utils rightLeftViewSlide:_galleryView withCGFloat:100.0];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 100.0;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return [_galleryArray count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *CellIdentifier = @"Cell";    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    NSArray     *   paths     =   NSSearchPathForDirectoriesInDomains(NSDocumentDirectory,NSUserDomainMask, YES);
    NSString    *   imgPath   =   [[paths objectAtIndex:0] stringByAppendingPathComponent:[[_galleryArray objectAtIndex:indexPath.row] objectAtIndex:3]];
    NSData      *   data        =   [NSData dataWithContentsOfFile:imgPath];    
    UIImage     *   img         =   [UIImage imageWithData:data]; 
    UIImageView *   imgView     =   [[UIImageView alloc] initWithFrame:CGRectMake(5, 5.0, 90, 60)];
    imgView.image = img;
    [cell addSubview:imgView];
    
    UIButton * delBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    delBtn = [utils setButtonPropertyWithButton:delBtn 
                                      withFrame:CGRectMake(10, 65.0, 35.0, 35.0) 
                                        withTag:indexPath.row
                                    withUpImage:[utils getImageFromName:@"deleteGalleryImage.png"] 
                                  withDownImage:[utils getImageFromName:@"deleteGalleryImage.png"]
                                     withTarget:self 
                                     withAction:@selector(delBtnPressed:)];
    [cell addSubview:delBtn];
    
    UIButton * sellBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    sellBtn = [utils setButtonPropertyWithButton:sellBtn 
                                       withFrame:CGRectMake(55.0, 65.0, 35.0, 35.0)
                                         withTag:indexPath.row
                                     withUpImage:[utils getImageFromName:@"sellGalleryImage.png"] 
                                   withDownImage:[utils getImageFromName:@"sellGalleryImage.png"] 
                                      withTarget:self 
                                      withAction:@selector(sellBtnPressed:)];
    [cell addSubview:sellBtn];
    return cell;
}

- (void)delBtnPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    UIButton * btn = (UIButton *)sender; 
    _btnId = btn.tag;
    
    UIAlertView * alertView = [[UIAlertView alloc] initWithTitle:@"Hint"
                                                         message:@"Delete this work?"
                                                        delegate:self
                                               cancelButtonTitle:@"NO"
                                               otherButtonTitles:@"YES", nil];
    alertView.tag = 0;
    [alertView show];
    [alertView release];
}

- (void)sellBtnPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    UIButton * btn = (UIButton *)sender; 
    _btnId = btn.tag;
   
    int roomValue = [[[_galleryArray objectAtIndex:_btnId] objectAtIndex:2] intValue];
    NSString * hintString = [NSString stringWithFormat:@"Sell the work for $%d",roomValue];
    UIAlertView * alertView = [[UIAlertView alloc] initWithTitle:@"Hint"
                                                         message:hintString
                                                        delegate:self
                                               cancelButtonTitle:@"NO"
                                               otherButtonTitles:@"YES", nil];
    alertView.tag = 1;
    [alertView show];
    [alertView release];
}




- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    if ([utils getSoundLastSave]) {
        [utils playCafSound:CFSTR("Tada")];
    }
    roomDesignController_iPhone * roomDesigner = [[roomDesignController_iPhone alloc] initWithIndex:[[[_galleryArray objectAtIndex:indexPath.row] objectAtIndex:1] intValue]];
    roomDesigner.bKId = [[[_galleryArray objectAtIndex:indexPath.row] objectAtIndex:0] intValue];
    roomDesigner.bKHomeValue = [[[_galleryArray objectAtIndex:indexPath.row] objectAtIndex:2] intValue];
    CATransition *transition = [CATransition animation];
    transition.duration = 0.8;
    transition.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut]; 
    transition.type = kCATransitionFade; 
    transition.delegate = self; 
    
    [self.navigationController.view.layer addAnimation:transition forKey:nil];   
    [self.navigationController pushViewController:roomDesigner animated:YES];
    [roomDesigner release];
}

- (void) initButtons{
    NSArray * imgArray = [NSArray arrayWithObjects:@"livingRoomButton.png",@"bedRoomButton.png",@"kitchenButton.png",@"bathRoomButton.png",nil];
    int x,y = 0;
    for (int i = 0; i < 4; i++) {
        x = i % 2;
        y = i / 2;
        UIButton * button = [UIButton buttonWithType:UIButtonTypeCustom];
        button = [utils setButtonPropertyWithButton:button 
                                          withFrame:CGRectMake(31+160*x, 40+130*y, 150, 110) 
                                            withTag:i
                                        withUpImage:[utils getImageFromName:[imgArray objectAtIndex:i]] 
                                      withDownImage:nil 
                                         withTarget:self 
                                         withAction:@selector(mainSelButtonPressed:)];
        [self.view addSubview:button];
    }
        
    if ([utils getbgMusicLastSave]) {
        _musicButton = [UIButton buttonWithType:UIButtonTypeCustom];
        _musicButton = [utils setButtonPropertyWithButton:_musicButton 
                                                withFrame:CGRectMake(0.0, 0.0, 35.0, 35.0) 
                                                  withTag:0 
                                              withUpImage:[utils getImageFromName:@"musicOn.png"] 
                                            withDownImage:[utils getImageFromName:@"musicOn.png"] 
                                               withTarget:self 
                                               withAction:@selector(musicButtonPressed:)];
        [self.view addSubview:_musicButton];
    }else{
        _musicButton = [UIButton buttonWithType:UIButtonTypeCustom];
        _musicButton = [utils setButtonPropertyWithButton:_musicButton 
                                                withFrame:CGRectMake(0.0, 0.0, 35.0, 35.0) 
                                                  withTag:0 
                                              withUpImage:[utils getImageFromName:@"musicOff.png"] 
                                            withDownImage:[utils getImageFromName:@"musicOff.png"] 
                                               withTarget:self 
                                               withAction:@selector(musicButtonPressed:)];
        [self.view addSubview:_musicButton];
    }
    
    if ([utils getSoundLastSave]) {
        _soundButton = [UIButton buttonWithType:UIButtonTypeCustom];
        _soundButton = [utils setButtonPropertyWithButton:_soundButton 
                                                withFrame:CGRectMake(40.0, 0.0, 35.0, 35.0) 
                                                  withTag:0 
                                              withUpImage:[utils getImageFromName:@"soundOn.png"] 
                                            withDownImage:[utils getImageFromName:@"soundOn.png"] 
                                               withTarget:self 
                                               withAction:@selector(soundButtonPressed:)];
        [self.view addSubview:_soundButton];
    }else{
        _soundButton = [UIButton buttonWithType:UIButtonTypeCustom];
        _soundButton = [utils setButtonPropertyWithButton:_soundButton 
                                                withFrame:CGRectMake(40.0, 0.0, 35.0, 35.0) 
                                                  withTag:0 
                                              withUpImage:[utils getImageFromName:@"soundOff.png"] 
                                            withDownImage:[utils getImageFromName:@"soundOff.png"] 
                                               withTarget:self 
                                               withAction:@selector(soundButtonPressed:)];
        [self.view addSubview:_soundButton];
    }
    
    UIButton * rateBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    rateBtn = [utils setButtonPropertyWithButton:rateBtn
                                       withFrame:CGRectMake(0.0, 280.0, 55.0, 35.0) 
                                         withTag:0
                                     withUpImage:[utils getImageFromName:@"rateBtn.png"] 
                                   withDownImage:[utils getImageFromName:@"rateBtn.png"] 
                                      withTarget:self 
                                      withAction:@selector(rateusButtonPressed:)];
    [self.view addSubview:rateBtn];
    
    reloadButton = [UIButton buttonWithType:UIButtonTypeCustom];
    reloadButton = [utils setButtonPropertyWithButton:reloadButton
                                            withFrame:CGRectMake(420.0, 0.0, 45.0, 45.0)
                                              withTag:0
                                          withUpImage:[utils getImageFromName:@"galleryButton.png"]
                                        withDownImage:[utils getImageFromName:@"galleryButton.png"]
                                           withTarget:self
                                           withAction:@selector(reloadButtonPressed:)];
    [self.view addSubview:reloadButton];
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    int bkId = 0;
    if (alertView.tag == 0) {
        switch (buttonIndex) {
            case 0:
                break;
            case 1:
                bkId = [[[_galleryArray objectAtIndex:_btnId] objectAtIndex:0] intValue];
                [utils removeImageItemFromDocumets:[NSString stringWithFormat:@"%d.png",bkId]];
                NSString * sqlString = [NSString stringWithFormat:@"delete from tb_saveBK where bKId = '%d'",bkId];
                NSString * sqlStringItem = [NSString stringWithFormat:@"delete from tb_saveItem where itemBk  = '%d'",bkId];
                if ([[SQLiteOperation sharedSQLOpt] dealData:sqlString paramArray:nil]) {
                    [[SQLiteOperation sharedSQLOpt] dealData:sqlStringItem paramArray:nil];
                }
                [_galleryArray removeObjectAtIndex:_btnId];
                [_tableView reloadData];
                break;
            default:
                break;
        }
    }else if(alertView.tag == 1){
        switch (buttonIndex) {
            case 0:
                break;
            case 1:
                bkId = [[[_galleryArray objectAtIndex:_btnId] objectAtIndex:0] intValue];
                int roomValue = [[[_galleryArray objectAtIndex:_btnId] objectAtIndex:2] intValue];
                [[coinManager sharedCoinManager] plusCoinValueWithChangedValue:roomValue];
                NSString * updateSql = [NSString stringWithFormat:@"update tb_saveBK set bKHomeValue = '0' where bKId = %d",bkId];
                [[SQLiteOperation sharedSQLOpt] dealData:updateSql paramArray:nil];
                //[[_galleryArray objectAtIndex:_btnId] objectAtIndex:2] = @"0";
                [[_galleryArray objectAtIndex:_btnId] replaceObjectAtIndex:2 withObject:@"0"];
                break;
            default:
                break;
        }
    }
        
}

- (void)reloadButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [utils playWavSound:CFSTR("ButtonAppear")];
    }
    roomAppDelegate * appDelegate   = (roomAppDelegate *)[[UIApplication sharedApplication] delegate];
    
    if (appDelegate.reloadDataFromDB == YES) {
        if (_galleryArray) {
            [_galleryArray release];
        }
        _galleryArray = [[[SQLiteOperation sharedSQLOpt] selectData:@"select bKId,bKImageName,bKHomeValue,bKIconName,bKOther from tb_saveBK" resultColumns:5] retain]; 
        appDelegate.reloadDataFromDB = NO;
    }
    
    
    iToast  *toast = nil;
    if ([_galleryArray retainCount] > 0) {
        if ([_galleryArray count] > 0) {
            [utils rightLeftViewSlide:_galleryView withCGFloat:-100.0];
            [_tableView reloadData];
        }else{
            toast = [iToast makeText:@"Gallery is empty. Please save your work after you have finished designing."];
            [toast setDuration:3000];
            [toast setGravity:iToastGravityBottom offsetLeft:50 offsetTop:210];
            [toast show];
        }
    }
    
}

- (void) rateusButtonPressed:(id)sender{
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"itms-apps://ax.itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?type=Purple+Software&id=%@", APP_ID]]];
}

- (void)musicButtonPressed:(id)sender{
    if ([utils getbgMusicLastSave]) {
        [_musicButton setBackgroundImage:[utils getImageFromName:@"musicOff.png"] forState:UIControlStateNormal];
        [utils setBGMusicLastSaveStatus:MUSIC_OFF];
        [_bgMusicPlayer pause];
    }else{
        [_musicButton setBackgroundImage:[utils getImageFromName:@"musicOn.png"] forState:UIControlStateNormal];
        [utils setBGMusicLastSaveStatus:MUSIC_ON];
        [_bgMusicPlayer play];
    }
}

- (void)soundButtonPressed:(id)sender{
    if ([utils getSoundLastSave]) {
        [_soundButton setBackgroundImage:[utils getImageFromName:@"soundOff.png"] forState:UIControlStateNormal];
        [utils setSoundLastSaveStatue:SOUND_OFF];
        
    }else{
        [_soundButton setBackgroundImage:[utils getImageFromName:@"soundOn.png"] forState:UIControlStateNormal];
        [utils setSoundLastSaveStatue:SOUND_ON];
    }
}

- (void) mainSelButtonPressed:(id)sender{
    UIButton * btn = (UIButton *)sender;
    if ([utils getSoundLastSave]) {
        [utils playCafSound:CFSTR("Tada")];
    }
    roomDesignController_iPhone * roomDesigner = [[roomDesignController_iPhone alloc] initWithIndex:btn.tag];
    roomDesigner.bKId = 0;
    CATransition *transition = [CATransition animation];
    transition.duration = 0.8;
    transition.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut]; 
    transition.type = kCATransitionFade; 
    transition.delegate = self; 
    
    [self.navigationController.view.layer addAnimation:transition forKey:nil];   
    [self.navigationController pushViewController:roomDesigner animated:YES];
    [roomDesigner release];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {    
    //return (interfaceOrientation == UIInterfaceOrientationLandscapeRight);
    if (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight) {
        return YES;
    }else{
        return NO;
    }
}



- (void)dealloc{    
    if (_galleryArray) {
        [_galleryArray release];
    }
    [_galleryView release];
    [_tableView release];
    [super dealloc];
}
@end
