//
//  scrollItemView_iPhone.m
//  room
//
//  Created by mac on 12-6-17.
//  Copyright 2012年 __MyCompanyName__. All rights reserved.
//

#import "scrollItemView_iPhone.h"


@implementation scrollItemView_iPhone
@synthesize isLoaded;

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code
    }
    return self;
}
- (id) initWithFrame:(CGRect)frame 
    withContentArray:(NSArray *)array 
           withIndex:(int)index 
          withTarget:(id)target 
          withAction:(SEL)action
{
    self = [super initWithFrame:frame];
    if(self){
        
        self.backgroundColor = [UIColor colorWithWhite:10.0 alpha:0.8];
        self.layer.masksToBounds = NO;
        self.layer.cornerRadius = 8;
        self.layer.shadowOffset = CGSizeMake(2, 0);
        self.layer.shadowRadius = 5;
        self.layer.shadowOpacity = 0.5;
        self.tag = index;
        _array  = array;
        _index  = index;
        _target = target;
        _action = action;
    
        
        isLoaded = NO;
    }
    return self;
}
/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect
{
    // Drawing code
}
*/

- (void) loadKitToView
{
    itemButton = [UIButton buttonWithType:UIButtonTypeCustom];
    UIImage * itemImg = [utils getImageFromName:[[_array objectAtIndex:_index] objectAtIndex:3]];
    itemButton = [utils setButtonPropertyWithButton:itemButton 
                                          withFrame:CGRectMake((65-itemImg.size.width*0.25)*0.5, 10+(80-itemImg.size.height*0.25)*0.5, itemImg.size.width*0.25, itemImg.size.height*0.25) 
                                            withTag:_index 
                                        withUpImage:itemImg 
                                      withDownImage:itemImg 
                                         withTarget:_target 
                                         withAction:_action];
                  
    [self addSubview:itemButton];
    
    UIImage * img = [UIImage imageNamed:@"moneyIcon"];
    moneyIcon = [[UIImageView alloc] initWithImage:img];
    moneyIcon.frame = CGRectMake(5, 3, img.size.width, img.size.height);
    [self addSubview:moneyIcon];
    
    priceLabel = [[UILabel alloc] initWithFrame:CGRectMake(25, 5, 40, 20)];
    priceLabel.backgroundColor = [UIColor clearColor];
    priceLabel.font = [UIFont fontWithName:@"Georgia-Bold" size:12.0];
    priceLabel.text = [[_array objectAtIndex:_index] objectAtIndex:4];
    [self addSubview:priceLabel];
    isLoaded = YES;
}

- (void) unloadKitFromView{
    for (UIView * view in [self subviews]) {
        [view removeFromSuperview];
    }
    isLoaded = NO;
}

- (void)dealloc
{
    [moneyIcon release];
    moneyIcon = nil;
    [priceLabel release];
    priceLabel = nil;
    
    _array = nil;
    _target = nil;
    _action = nil;
    [super dealloc];
}

@end
